﻿Option Strict Off
Imports System.IO
Public Class 系統權限預設表
    Dim HH As String : Dim 職稱 As String
    Dim RI As Integer = -1
    Dim SK As String = "要查找的 KEY"
    Dim Str As String = Application.StartupPath
    ReadOnly 對話框(0) As String
    Private Sub Set_權限清單()
        Dim ds As New DataSet
        清單_dgv.DataSource = Nothing : ds.Clear()
        清單_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        清單_dgv.ColumnHeadersHeight = 25 : 清單_dgv.AllowUserToAddRows = False : 清單_dgv.RowTemplate.Height = 25

        If 小間距1_ch.Checked = False And 中間距1_ch.Checked = False And 大間距1_ch.Checked = True Then : 清單_dgv.RowTemplate.Height = 75
        ElseIf 小間距1_ch.Checked = False And 中間距1_ch.Checked = True And 大間距1_ch.Checked = False Then : 清單_dgv.RowTemplate.Height = 45
        ElseIf 小間距1_ch.Checked = True And 中間距1_ch.Checked = False And 大間距1_ch.Checked = False Then : 清單_dgv.RowTemplate.Height = 25 : End If
        SQL_系統權限預設表()
        da.Fill(ds) : 清單_dgv.DataSource = ds.Tables(0) : conn.Close()

        清單_dgv.Columns(0).FillWeight = 150 : 清單_dgv.Columns(1).FillWeight = 30
        For i As Integer = 0 To 權限數量 - 1
            清單_dgv.Columns(i + 2).Visible = False
        Next
    End Sub
    Private Sub Set_權限清單1()
        Dim ds1 As New DataSet
        清單1_dgv.DataSource = Nothing : ds1.Clear()
        清單1_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        清單1_dgv.ColumnHeadersHeight = 25 : 清單1_dgv.AllowUserToAddRows = False : 清單1_dgv.RowTemplate.Height = 25
        If 小間距1_ch.Checked = False And 中間距1_ch.Checked = False And 大間距1_ch.Checked = True Then : 清單1_dgv.RowTemplate.Height = 75
        ElseIf 小間距1_ch.Checked = False And 中間距1_ch.Checked = True And 大間距1_ch.Checked = False Then : 清單1_dgv.RowTemplate.Height = 45
        ElseIf 小間距1_ch.Checked = True And 中間距1_ch.Checked = False And 大間距1_ch.Checked = False Then : 清單1_dgv.RowTemplate.Height = 25 : End If
        SQL_系統權限預設表()
        da.Fill(ds1) : 清單1_dgv.DataSource = ds1.Tables(0) : conn.Close()
        清單1_dgv.Columns(0).ReadOnly = True : 清單1_dgv.Columns(1).ReadOnly = True
        清單1_dgv.Columns(0).FillWeight = 150 : 清單1_dgv.Columns(1).FillWeight = 30
        For i As Integer = 0 To 權限數量 - 1
            清單1_dgv.Columns(i + 2).Visible = False
        Next
        For i As Integer = 0 To 清單1_dgv.Rows.Count - 1
            Dim 驗證 As String = "" : Dim 取變數 As String : NN1 = 0
            取變數 = 清單1_dgv.Rows(i).Cells("職稱").Value
            For ii As Integer = 1 To 20
                If ii = 1 Then : 驗證 = Strings.Left(取變數, ii) : NN1 += 1 : Else
                    If Strings.Mid(取變數, ii, 1) = "/" Then : Exit For : Else : 驗證 &= Strings.Mid(取變數, ii, 1) : NN1 += 1 : End If
                End If
            Next
            If 系統語言 = "繁體中文" Then : 清單1_dgv.Rows(i).Cells("職稱").Value = 驗證 : Else
                驗證 = Strings.Left(清單1_dgv.Rows(i).Cells(0).Value.ToString, 6) & Strings.Mid(清單1_dgv.Rows(i).Cells(0).Value.ToString, NN1 + 2, 100)
                If 驗證 = "00000." Then : 清單1_dgv.Rows(i).Cells("職稱").Value = "00000.NA" : Else : 清單1_dgv.Rows(i).Cells("職稱").Value = 驗證 : End If
            End If
        Next
    End Sub
    Private Sub Set_語言()
        語言_dgv.DataSource = Nothing
        語言_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        語言_dgv.ColumnHeadersHeight = 25
        語言_dgv.AllowUserToAddRows = False
        For i As Integer = 0 To 語言_dgv.Rows.Count - 1 : 語言_dgv.Rows.RemoveAt(0) : Next
        If File.Exists(Str + "\LANGUAGE_FILE.csv") Then
            Dim filereader = My.Computer.FileSystem.OpenTextFileReader(Str + "\LANGUAGE_FILE.csv", System.Text.Encoding.Default)
            Dim line As String = filereader.ReadLine()
            While Not (line Is Nothing)
                line = filereader.ReadLine()
                If line <> Nothing Then
                    line = line.Replace("""", "")
                    If Strings.Left(line, 4) = "G000" Or Strings.Left(line, 4) = "H001" Or Strings.Left(line, 8) = "H000-121" Or Strings.Left(line, 4) = 介面 Then
                        If 系統語言 = "繁體中文" Then
                            If Strings.Mid(line, 10, 2) = "CH" Then : 語言_dgv.Rows.Insert(0)
                                語言_dgv.Rows(0).Cells(0).Value = Strings.Left(line, 11)
                                If Strings.Mid(line, 13, 300).EndsWith(",") Then
                                    語言_dgv.Rows(0).Cells(1).Value = Strings.Mid(line, 13, 300).Substring(0, Strings.Mid(line, 13, 300).Length - 1)
                                Else : 語言_dgv.Rows(0).Cells(1).Value = Strings.Mid(line, 13, 300) : End If
                            End If
                        ElseIf 系統語言 = "English" Then
                            If Strings.Mid(line, 10, 2) = "EN" Then : 語言_dgv.Rows.Insert(0)
                                語言_dgv.Rows(0).Cells(0).Value = Strings.Left(line, 11)
                                If Strings.Mid(line, 13, 300).EndsWith(",") Then
                                    語言_dgv.Rows(0).Cells(1).Value = Strings.Mid(line, 13, 300).Substring(0, Strings.Mid(line, 13, 300).Length - 1)
                                Else : 語言_dgv.Rows(0).Cells(1).Value = Strings.Mid(line, 13, 300) : End If
                            End If
                        ElseIf 系統語言 = "Indonesian" Then
                            If Strings.Mid(line, 10, 2) = "IN" Then : 語言_dgv.Rows.Insert(0)
                                語言_dgv.Rows(0).Cells(0).Value = Strings.Left(line, 11)
                                If Strings.Mid(line, 13, 300).EndsWith(",") Then
                                    語言_dgv.Rows(0).Cells(1).Value = Strings.Mid(line, 13, 300).Substring(0, Strings.Mid(line, 13, 300).Length - 1)
                                Else : 語言_dgv.Rows(0).Cells(1).Value = Strings.Mid(line, 13, 300) : End If
                            End If
                        End If
                    End If
                End If
            End While
            filereader.Close()
        End If
    End Sub
    Private Sub Set_語言查詢()
        RI = -1 : For Each row As DataGridViewRow In 語言_dgv.Rows
            If Strings.Left(row.Cells(0).Value.ToString(), 8) = SK Then
                RI = row.Index : Exit For
            End If
        Next
    End Sub
    Private Sub 語言轉換讀取()
        Set_語言()
        SK = "G000-110" : Set_語言查詢() : 修改_bt.Text = 語言_dgv(1, RI).Value.ToString : SK = "G000-119" : Set_語言查詢() : 對話框(0) = 語言_dgv(1, RI).Value.ToString
        '------------------------業務管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        SK = "H001-204" : Set_語言查詢() : 業務權限_tp.Text = 語言_dgv(1, RI).Value.ToString : SK = "H001-204" : Set_語言查詢() : CheckBox5.Text = 語言_dgv(1, RI).Value.ToString & "-005"
        SK = "H001-121" : Set_語言查詢() : CheckBox60.Text = 語言_dgv(1, RI).Value.ToString & "-060" : SK = "H001-124" : Set_語言查詢() : CheckBox116.Text = 語言_dgv(1, RI).Value.ToString & "-116"
        SK = "H001-125" : Set_語言查詢() : CheckBox107.Text = 語言_dgv(1, RI).Value.ToString & "-107" : SK = "H001-128" : Set_語言查詢() : CheckBox98.Text = 語言_dgv(1, RI).Value.ToString & "-098"
        SK = "H001-130" : Set_語言查詢() : CheckBox123.Text = 語言_dgv(1, RI).Value.ToString & "-123" : SK = "H001-131" : Set_語言查詢() : CheckBox124.Text = 語言_dgv(1, RI).Value.ToString & "-124"
        SK = "H001-132" : Set_語言查詢() : CheckBox125.Text = 語言_dgv(1, RI).Value.ToString & "-125" : SK = "H001-133" : Set_語言查詢() : CheckBox126.Text = 語言_dgv(1, RI).Value.ToString & "-126"
        SK = "H001-122" : Set_語言查詢() : CheckBox127.Text = 語言_dgv(1, RI).Value.ToString & "-127" : SK = "H001-119" : Set_語言查詢() : CheckBox61.Text = 語言_dgv(1, RI).Value.ToString & "-061"
        SK = "H001-126" : Set_語言查詢() : CheckBox128.Text = 語言_dgv(1, RI).Value.ToString & "-128" : SK = "H001-120" : Set_語言查詢() : CheckBox62.Text = 語言_dgv(1, RI).Value.ToString & "-062"
        SK = "H001-109" : Set_語言查詢() : CheckBox52.Text = 語言_dgv(1, RI).Value.ToString & "-052" : SK = "H001-103" : Set_語言查詢() : CheckBox114.Text = 語言_dgv(1, RI).Value.ToString & "-114"
        SK = "H001-165" : Set_語言查詢() : CheckBox99.Text = 語言_dgv(1, RI).Value.ToString & "-099" : SK = "H001-260" : Set_語言查詢() : CheckBox101.Text = 語言_dgv(1, RI).Value.ToString & "-101"
        SK = "H001-261" : Set_語言查詢() : CheckBox102.Text = 語言_dgv(1, RI).Value.ToString & "-102" : SK = "H001-262" : Set_語言查詢() : CheckBox103.Text = 語言_dgv(1, RI).Value.ToString & "-103"
        '------------------------採購管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        SK = "H001-189" : Set_語言查詢() : 採購權限_tp.Text = 語言_dgv(1, RI).Value.ToString : SK = "H001-189" : Set_語言查詢() : CheckBox6.Text = 語言_dgv(1, RI).Value.ToString & "-006"
        SK = "H001-174" : Set_語言查詢() : CheckBox33.Text = 語言_dgv(1, RI).Value.ToString & "-033" : SK = "H001-175" : Set_語言查詢() : CheckBox34.Text = 語言_dgv(1, RI).Value.ToString & "-034"
        SK = "H001-173" : Set_語言查詢() : CheckBox35.Text = 語言_dgv(1, RI).Value.ToString & "-035" : SK = "H001-190" : Set_語言查詢() : CheckBox20.Text = 語言_dgv(1, RI).Value.ToString & "-020"
        SK = "H001-171" : Set_語言查詢() : CheckBox36.Text = 語言_dgv(1, RI).Value.ToString & "-036" : SK = "H001-168" : Set_語言查詢() : CheckBox73.Text = 語言_dgv(1, RI).Value.ToString & "-073"
        SK = "H001-170" : Set_語言查詢() : CheckBox37.Text = 語言_dgv(1, RI).Value.ToString & "-037" : SK = "H001-169" : Set_語言查詢() : CheckBox38.Text = 語言_dgv(1, RI).Value.ToString & "-038"
        SK = "H001-166" : Set_語言查詢() : CheckBox39.Text = 語言_dgv(1, RI).Value.ToString & "-039" : SK = "H001-143" : Set_語言查詢() : CheckBox25.Text = 語言_dgv(1, RI).Value.ToString & "-025"
        SK = "H001-144" : Set_語言查詢() : CheckBox26.Text = 語言_dgv(1, RI).Value.ToString & "-026" : SK = "H001-142" : Set_語言查詢() : CheckBox27.Text = 語言_dgv(1, RI).Value.ToString & "-027"
        SK = "H001-140" : Set_語言查詢() : CheckBox28.Text = 語言_dgv(1, RI).Value.ToString & "-028" : SK = "H001-137" : Set_語言查詢() : CheckBox72.Text = 語言_dgv(1, RI).Value.ToString & "-072"
        SK = "H001-139" : Set_語言查詢() : CheckBox29.Text = 語言_dgv(1, RI).Value.ToString & "-029" : SK = "H001-138" : Set_語言查詢() : CheckBox30.Text = 語言_dgv(1, RI).Value.ToString & "-030"
        SK = "H001-136" : Set_語言查詢() : CheckBox31.Text = 語言_dgv(1, RI).Value.ToString & "-031" : SK = "H001-167" : Set_語言查詢() : CheckBox11.Text = 語言_dgv(1, RI).Value.ToString & "-011"
        SK = "H001-135" : Set_語言查詢() : CheckBox42.Text = 語言_dgv(1, RI).Value.ToString & "-042" : SK = "H001-160" : Set_語言查詢() : CheckBox51.Text = 語言_dgv(1, RI).Value.ToString & "-051"
        SK = "H001-263" : Set_語言查詢() : CheckBox12.Text = 語言_dgv(1, RI).Value.ToString & "-012" : SK = "H001-264" : Set_語言查詢() : CheckBox13.Text = 語言_dgv(1, RI).Value.ToString & "-013"
        SK = "H001-265" : Set_語言查詢() : CheckBox14.Text = 語言_dgv(1, RI).Value.ToString & "-014"
        '------------------------工程管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        SK = "H001-106" : Set_語言查詢() : 技術權限_tp.Text = 語言_dgv(1, RI).Value.ToString : SK = "H001-106" : Set_語言查詢() : CheckBox8.Text = 語言_dgv(1, RI).Value.ToString & "-008"
        SK = "H001-133" : Set_語言查詢() : CheckBox105.Text = 語言_dgv(1, RI).Value.ToString & "-105" : SK = "H001-132" : Set_語言查詢() : CheckBox108.Text = 語言_dgv(1, RI).Value.ToString & "-108"
        SK = "H001-126" : Set_語言查詢() : CheckBox109.Text = 語言_dgv(1, RI).Value.ToString & "-109" : SK = "H001-108" : Set_語言查詢() : CheckBox110.Text = 語言_dgv(1, RI).Value.ToString & "-110"
        SK = "H001-176" : Set_語言查詢() : CheckBox106.Text = 語言_dgv(1, RI).Value.ToString & "-106" : SK = "H001-104" : Set_語言查詢() : CheckBox104.Text = 語言_dgv(1, RI).Value.ToString & "-104"
        SK = "H001-107" : Set_語言查詢() : CheckBox53.Text = 語言_dgv(1, RI).Value.ToString & "-053" : SK = "H001-110" : Set_語言查詢() : CheckBox54.Text = 語言_dgv(1, RI).Value.ToString & "-054"
        '------------------------倉儲管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        SK = "H001-180" : Set_語言查詢() : 倉儲權限_tp.Text = 語言_dgv(1, RI).Value.ToString : SK = "H001-180" : Set_語言查詢() : CheckBox9.Text = 語言_dgv(1, RI).Value.ToString & "-009"
        SK = "H001-227" : Set_語言查詢() : CheckBox46.Text = 語言_dgv(1, RI).Value.ToString & "-046" : SK = "H001-223" : Set_語言查詢() : CheckBox47.Text = 語言_dgv(1, RI).Value.ToString & "-047"
        SK = "H001-224" : Set_語言查詢() : CheckBox48.Text = 語言_dgv(1, RI).Value.ToString & "-048" : SK = "H001-225" : Set_語言查詢() : CheckBox49.Text = 語言_dgv(1, RI).Value.ToString & "-049"
        SK = "H001-226" : Set_語言查詢() : CheckBox50.Text = 語言_dgv(1, RI).Value.ToString & "-050" : SK = "H001-186" : Set_語言查詢() : CheckBox56.Text = 語言_dgv(1, RI).Value.ToString & "-056"
        SK = "H001-187" : Set_語言查詢() : CheckBox57.Text = 語言_dgv(1, RI).Value.ToString & "-057" : SK = "H001-185" : Set_語言查詢() : CheckBox58.Text = 語言_dgv(1, RI).Value.ToString & "-058"
        SK = "H001-159" : Set_語言查詢() : CheckBox59.Text = 語言_dgv(1, RI).Value.ToString & "-059" : SK = "H001-161" : Set_語言查詢() : CheckBox70.Text = 語言_dgv(1, RI).Value.ToString & "-070"
        SK = "H001-179" : Set_語言查詢() : CheckBox71.Text = 語言_dgv(1, RI).Value.ToString & "-071" : SK = "H001-181" : Set_語言查詢() : CheckBox69.Text = 語言_dgv(1, RI).Value.ToString & "-069"
        SK = "H001-213" : Set_語言查詢() : CheckBox85.Text = 語言_dgv(1, RI).Value.ToString & "-085" : SK = "H001-214" : Set_語言查詢() : CheckBox86.Text = 語言_dgv(1, RI).Value.ToString & "-086"
        '------------------------財務管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        SK = "H001-182" : Set_語言查詢() : 財務權限_tp.Text = 語言_dgv(1, RI).Value.ToString : SK = "H001-182" : Set_語言查詢() : CheckBox7.Text = 語言_dgv(1, RI).Value.ToString & "-007"
        SK = "H001-220" : Set_語言查詢() : CheckBox91.Text = 語言_dgv(1, RI).Value.ToString & "-091" : SK = "H001-222" : Set_語言查詢() : CheckBox92.Text = 語言_dgv(1, RI).Value.ToString & "-092"
        SK = "H001-219" : Set_語言查詢() : CheckBox93.Text = 語言_dgv(1, RI).Value.ToString & "-093" : SK = "H001-221" : Set_語言查詢() : CheckBox94.Text = 語言_dgv(1, RI).Value.ToString & "-094"
        SK = "H001-218" : Set_語言查詢() : CheckBox95.Text = 語言_dgv(1, RI).Value.ToString & "-095" : SK = "H001-201" : Set_語言查詢() : CheckBox96.Text = 語言_dgv(1, RI).Value.ToString & "-096"
        SK = "H001-202" : Set_語言查詢() : CheckBox97.Text = 語言_dgv(1, RI).Value.ToString & "-097" : SK = "H001-210" : Set_語言查詢() : CheckBox18.Text = 語言_dgv(1, RI).Value.ToString & "-018"
        SK = "H001-207" : Set_語言查詢() : CheckBox64.Text = 語言_dgv(1, RI).Value.ToString & "-064" : SK = "H001-208" : Set_語言查詢() : CheckBox65.Text = 語言_dgv(1, RI).Value.ToString & "-065"
        SK = "H001-211" : Set_語言查詢() : CheckBox66.Text = 語言_dgv(1, RI).Value.ToString & "-066" : SK = "H001-209" : Set_語言查詢() : CheckBox90.Text = 語言_dgv(1, RI).Value.ToString & "-090"
        '------------------------人事管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        SK = "H001-101" : Set_語言查詢() : 人事權限_tp.Text = 語言_dgv(1, RI).Value.ToString : SK = "H001-101" : Set_語言查詢() : CheckBox22.Text = 語言_dgv(1, RI).Value.ToString & "-022"
        SK = "H001-146" : Set_語言查詢() : CheckBox55.Text = 語言_dgv(1, RI).Value.ToString & "-055" : SK = "H001-102" : Set_語言查詢() : CheckBox23.Text = 語言_dgv(1, RI).Value.ToString & "-023"
        SK = "H001-266" : Set_語言查詢() : CheckBox24.Text = 語言_dgv(1, RI).Value.ToString & "-024" : SK = "H001-151" : Set_語言查詢() : CheckBox89.Text = 語言_dgv(1, RI).Value.ToString & "-089"
        SK = "H001-158" : Set_語言查詢() : CheckBox111.Text = 語言_dgv(1, RI).Value.ToString & "-111" : SK = "H001-162" : Set_語言查詢() : CheckBox112.Text = 語言_dgv(1, RI).Value.ToString & "-112"
        SK = "H001-183" : Set_語言查詢() : CheckBox113.Text = 語言_dgv(1, RI).Value.ToString & "-113" : SK = "H001-269" : Set_語言查詢() : CheckBox17.Text = 語言_dgv(1, RI).Value.ToString & "-017"
        SK = "H001-270" : Set_語言查詢() : CheckBox16.Text = 語言_dgv(1, RI).Value.ToString & "-016" : SK = "H001-271" : Set_語言查詢() : CheckBox15.Text = 語言_dgv(1, RI).Value.ToString & "-015"
        SK = "H000-121" : Set_語言查詢() : CheckBox80.Text = 語言_dgv(1, RI).Value.ToString & "-080" : SK = "H001-272" : Set_語言查詢() : CheckBox81.Text = 語言_dgv(1, RI).Value.ToString & "-081"
        '------------------------資料庫管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        SK = "H001-205" : Set_語言查詢() : 資料庫權限_tp.Text = 語言_dgv(1, RI).Value.ToString : SK = "H001-205" : Set_語言查詢() : CheckBox1.Text = 語言_dgv(1, RI).Value.ToString & "-001"
        SK = "H001-146" : Set_語言查詢() : CheckBox2.Text = 語言_dgv(1, RI).Value.ToString & "-002" : SK = "H001-156" : Set_語言查詢() : CheckBox84.Text = 語言_dgv(1, RI).Value.ToString & "-084"
        SK = "H001-150" : Set_語言查詢() : CheckBox41.Text = 語言_dgv(1, RI).Value.ToString & "-041" : SK = "H001-195" : Set_語言查詢() : CheckBox87.Text = 語言_dgv(1, RI).Value.ToString & "-087"
        SK = "H001-152" : Set_語言查詢() : CheckBox43.Text = 語言_dgv(1, RI).Value.ToString & "-043" : SK = "H001-155" : Set_語言查詢() : CheckBox10.Text = 語言_dgv(1, RI).Value.ToString & "-010"
        SK = "H001-154" : Set_語言查詢() : CheckBox44.Text = 語言_dgv(1, RI).Value.ToString & "-044" : SK = "H001-149" : Set_語言查詢() : CheckBox4.Text = 語言_dgv(1, RI).Value.ToString & "-004"
        SK = "H001-100" : Set_語言查詢() : CheckBox3.Text = 語言_dgv(1, RI).Value.ToString & "-003" : SK = "H001-153" : Set_語言查詢() : CheckBox19.Text = 語言_dgv(1, RI).Value.ToString & "-019"
        SK = "H001-232" : Set_語言查詢() : CheckBox21.Text = 語言_dgv(1, RI).Value.ToString & "-021" : SK = "H001-267" : Set_語言查詢() : CheckBox45.Text = 語言_dgv(1, RI).Value.ToString & "-045"
        SK = "H001-268" : Set_語言查詢() : CheckBox88.Text = 語言_dgv(1, RI).Value.ToString & "-088"
    End Sub

    Private Sub 系統權限預設表_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = OW_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        風格() : H(2) = True : 介面 = "H002" : 語言轉換讀取() : Panel1.SendToBack() : 清單_dgv.SendToBack()
        Set_權限清單() : Set_權限清單1()

        For no As Integer = 1 To 權限數量
            Dim 選擇1 As CheckBox = CType(Me.Controls.Find("CheckBox" + no.ToString(), True)(0), CheckBox)
        Next
        MyMod.清單字體大小調整()
        清單_dgv.RowsDefaultCellStyle.Font = New System.Drawing.Font("微軟正黑體", 7.6)
        清單1_dgv.RowsDefaultCellStyle.Font = New System.Drawing.Font("微軟正黑體", 7.6)
    End Sub
    Private Sub 系統權限預設表_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyMod.虛擬桌面開啟()
    End Sub
    Private Sub 系統權限預設表_SizeChanged(sender As Object, e As EventArgs) Handles MyBase.SizeChanged
        MyMod.清單字體大小調整()
        清單_dgv.RowsDefaultCellStyle.Font = New System.Drawing.Font("微軟正黑體", 7.6)
        清單1_dgv.RowsDefaultCellStyle.Font = New System.Drawing.Font("微軟正黑體", 7.6)
    End Sub
    Private Sub 職稱_dgv_RowPostPaint(ByVal sender As Object, ByVal e As DataGridViewRowPostPaintEventArgs) Handles 清單1_dgv.RowPostPaint
        Dim linePen As New Pen(Color.Blue, 2)
        If e.RowIndex = 清單1_dgv.Rows.Count - 1 Then
            Exit Sub
        Else
            If 清單1_dgv(1, e.RowIndex).Value.ToString = "02" Then
                Dim startX As Integer = IIf(清單1_dgv.RowHeadersVisible, 清單1_dgv.RowHeadersWidth, 0)
                Dim startY As Integer = e.RowBounds.Top + e.RowBounds.Height - 1
                Dim endX As Integer = startX + 清單1_dgv.Columns.GetColumnsWidth(DataGridViewElementStates.Visible) - 清單1_dgv.HorizontalScrollingOffset
                e.Graphics.DrawLine(linePen, startX, startY, endX, startY)
                Exit Sub
            End If
        End If
        For i As Integer = 0 To 清單1_dgv.Rows.Count - 1
            If 深色風格 = False Then
                If 清單1_dgv.Rows(i).Cells("級別").Value.ToString = "01" Then : 清單1_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightGoldenrodYellow
                ElseIf 清單1_dgv.Rows(i).Cells("級別").Value.ToString = "02" Then : 清單1_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightGreen
                ElseIf 清單1_dgv.Rows(i).Cells("級別").Value.ToString = "03" Then : 清單1_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightPink
                ElseIf 清單1_dgv.Rows(i).Cells("級別").Value.ToString = "04" Then : 清單1_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightBlue
                ElseIf 清單1_dgv.Rows(i).Cells("級別").Value.ToString = "05" Then : 清單1_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightBlue : End If
            Else
                If 清單1_dgv.Rows(i).Cells("級別").Value.ToString = "01" Then : 清單1_dgv.Rows(i).DefaultCellStyle.BackColor = Color.Purple
                ElseIf 清單1_dgv.Rows(i).Cells("級別").Value.ToString = "02" Then : 清單1_dgv.Rows(i).DefaultCellStyle.BackColor = Color.DarkGreen
                ElseIf 清單1_dgv.Rows(i).Cells("級別").Value.ToString = "03" Then : 清單1_dgv.Rows(i).DefaultCellStyle.BackColor = Color.DarkRed
                ElseIf 清單1_dgv.Rows(i).Cells("級別").Value.ToString = "04" Then : 清單1_dgv.Rows(i).DefaultCellStyle.BackColor = Color.DarkBlue
                ElseIf 清單1_dgv.Rows(i).Cells("級別").Value.ToString = "05" Then : 清單1_dgv.Rows(i).DefaultCellStyle.BackColor = Color.DarkBlue : End If
            End If
        Next
    End Sub
    Private Sub 清單1_dgv_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles 清單1_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            職稱 = 清單_dgv.Rows(e.RowIndex).Cells("職稱").Value
            For no As Integer = 1 To 權限數量
                If no < 10 Then : HH = "0" & no : ElseIf no >= 10 Then : HH = no : End If
                Dim 選擇 As CheckBox = CType(Me.Controls.Find("CheckBox" + no.ToString(), True)(0), CheckBox)
                選擇.Checked = 清單_dgv.Rows(e.RowIndex).Cells("CC" & HH).Value
            Next
        End If
    End Sub
    Private Sub 修改_bt_Click(sender As Object, e As EventArgs) Handles 修改_bt.Click
        PA10 = 職稱 : PA = "系統權限預設表" : SQL_系統權限預設表修改() : PA = "使用者權限管理表" : SQL_系統權限預設表修改() : PA = "" : Set_權限清單()
        MGB(對話框(0), 1)
    End Sub
    Private Sub 小間距1_ch_CheckedChanged(sender As Object, e As EventArgs) Handles 小間距1_ch.Click
        小間距1_ch.Checked = True : 中間距1_ch.Checked = False : 大間距1_ch.Checked = False : MyMod.間距設定存檔_1() : Set_權限清單() : Set_權限清單1()
    End Sub
    Private Sub 中間距1_ch_CheckedChanged(sender As Object, e As EventArgs) Handles 中間距1_ch.Click
        小間距1_ch.Checked = False : 中間距1_ch.Checked = True : 大間距1_ch.Checked = False : MyMod.間距設定存檔_2() : Set_權限清單() : Set_權限清單1()
    End Sub
    Private Sub 大間距1_ch_CheckedChanged(sender As Object, e As EventArgs) Handles 大間距1_ch.Click
        小間距1_ch.Checked = False : 中間距1_ch.Checked = False : 大間距1_ch.Checked = True : MyMod.間距設定存檔_3() : Set_權限清單() : Set_權限清單1()
    End Sub
    Private Sub 語轉扭_bt_Click(sender As Object, e As EventArgs) Handles 語轉扭_bt.Click
        介面 = "H002" : 語言轉換讀取() : Set_權限清單() : Set_權限清單1()
    End Sub

    Private Sub 風格()
        If 深色風格 = False Then
            Me.BackColor = SystemColors.Control : 業務權限_tp.BackColor = SystemColors.Control : 採購權限_tp.BackColor = SystemColors.Control
            技術權限_tp.BackColor = SystemColors.Control : 倉儲權限_tp.BackColor = SystemColors.Control : 財務權限_tp.BackColor = SystemColors.Control
            人事權限_tp.BackColor = SystemColors.Control : 資料庫權限_tp.BackColor = SystemColors.Control
            '----------------黑-------------------------------------------
            小間距1_ch.ForeColor = Color.Black : 中間距1_ch.ForeColor = Color.Black : 大間距1_ch.ForeColor = Color.Black
            CheckBox1.ForeColor = Color.Black : CheckBox22.ForeColor = Color.Black : CheckBox7.ForeColor = Color.Black : CheckBox5.ForeColor = Color.Black
            CheckBox9.ForeColor = Color.Black : CheckBox8.ForeColor = Color.Black : CheckBox6.ForeColor = Color.Black
            '----------------紅-------------------------------------------
            CheckBox74.ForeColor = Color.Red : CheckBox75.ForeColor = Color.Red : CheckBox2.ForeColor = Color.Red : CheckBox45.ForeColor = Color.Red
            CheckBox84.ForeColor = Color.Red : CheckBox41.ForeColor = Color.Red : CheckBox87.ForeColor = Color.Red : CheckBox88.ForeColor = Color.Red
            CheckBox43.ForeColor = Color.Red : CheckBox10.ForeColor = Color.Red : CheckBox44.ForeColor = Color.Red : CheckBox4.ForeColor = Color.Red
            CheckBox3.ForeColor = Color.Red : CheckBox23.ForeColor = Color.Red : CheckBox24.ForeColor = Color.Red : CheckBox89.ForeColor = Color.Red
            CheckBox91.ForeColor = Color.Red : CheckBox92.ForeColor = Color.Red : CheckBox93.ForeColor = Color.Red : CheckBox94.ForeColor = Color.Red
            CheckBox95.ForeColor = Color.Red : CheckBox96.ForeColor = Color.Red : CheckBox97.ForeColor = Color.Red : CheckBox46.ForeColor = Color.Red
            CheckBox47.ForeColor = Color.Red : CheckBox48.ForeColor = Color.Red : CheckBox49.ForeColor = Color.Red : CheckBox50.ForeColor = Color.Red
            CheckBox25.ForeColor = Color.Red : CheckBox26.ForeColor = Color.Red : CheckBox27.ForeColor = Color.Red : CheckBox60.ForeColor = Color.Red
            CheckBox116.ForeColor = Color.Red : CheckBox107.ForeColor = Color.Red : CheckBox98.ForeColor = Color.Red : CheckBox101.ForeColor = Color.Red
            CheckBox103.ForeColor = Color.Red : CheckBox102.ForeColor = Color.Red : CheckBox33.ForeColor = Color.Red : CheckBox34.ForeColor = Color.Red
            CheckBox35.ForeColor = Color.Red : CheckBox90.ForeColor = Color.Red : CheckBox15.ForeColor = Color.Red : CheckBox16.ForeColor = Color.Red
            CheckBox17.ForeColor = Color.Red : CheckBox109.ForeColor = Color.Red : CheckBox108.ForeColor = Color.Red : CheckBox105.ForeColor = Color.Red
            CheckBox53.ForeColor = Color.Red : CheckBox104.ForeColor = Color.Red : CheckBox106.ForeColor = Color.Red : CheckBox110.ForeColor = Color.Red
            CheckBox54.ForeColor = Color.Red : CheckBox55.ForeColor = Color.Red
            '----------------藍-------------------------------------------
            CheckBox40.ForeColor = Color.Blue : CheckBox32.ForeColor = Color.Blue : CheckBox61.ForeColor = Color.Blue : CheckBox99.ForeColor = Color.Blue
            CheckBox62.ForeColor = Color.Blue : CheckBox114.ForeColor = Color.Blue : CheckBox52.ForeColor = Color.Blue : CheckBox51.ForeColor = Color.Blue
            CheckBox42.ForeColor = Color.Blue : CheckBox11.ForeColor = Color.Blue : CheckBox12.ForeColor = Color.Blue : CheckBox13.ForeColor = Color.Blue
            CheckBox14.ForeColor = Color.Blue : CheckBox100.ForeColor = Color.Blue : CheckBox69.ForeColor = Color.Blue : CheckBox70.ForeColor = Color.Blue
            CheckBox71.ForeColor = Color.Blue : CheckBox18.ForeColor = Color.Blue : CheckBox111.ForeColor = Color.Blue : CheckBox112.ForeColor = Color.Blue
            CheckBox113.ForeColor = Color.Blue : CheckBox19.ForeColor = Color.Blue : CheckBox21.ForeColor = Color.Blue : CheckBox76.ForeColor = Color.Blue
            CheckBox67.ForeColor = Color.Blue : CheckBox65.ForeColor = Color.Blue : CheckBox79.ForeColor = Color.Blue : CheckBox77.ForeColor = Color.Blue
            CheckBox68.ForeColor = Color.Blue : CheckBox66.ForeColor = Color.Blue : CheckBox64.ForeColor = Color.Blue : CheckBox78.ForeColor = Color.Blue
            CheckBox63.ForeColor = Color.Blue : CheckBox129.ForeColor = Color.Blue
            '----------------綠-------------------------------------------
            CheckBox123.ForeColor = Color.Green : CheckBox124.ForeColor = Color.Green : CheckBox125.ForeColor = Color.Green : CheckBox126.ForeColor = Color.Green
            CheckBox127.ForeColor = Color.Green : CheckBox128.ForeColor = Color.Green : CheckBox20.ForeColor = Color.Green : CheckBox36.ForeColor = Color.Green
            CheckBox73.ForeColor = Color.Green : CheckBox37.ForeColor = Color.Green : CheckBox38.ForeColor = Color.Green : CheckBox39.ForeColor = Color.Green
            CheckBox28.ForeColor = Color.Green : CheckBox72.ForeColor = Color.Green : CheckBox29.ForeColor = Color.Green : CheckBox30.ForeColor = Color.Green
            CheckBox31.ForeColor = Color.Green : CheckBox82.ForeColor = Color.Green : CheckBox83.ForeColor = Color.Green : CheckBox81.ForeColor = Color.Green
            CheckBox80.ForeColor = Color.Green : CheckBox58.ForeColor = Color.Green : CheckBox57.ForeColor = Color.Green : CheckBox56.ForeColor = Color.Green
            CheckBox59.ForeColor = Color.Green : CheckBox85.ForeColor = Color.Green : CheckBox86.ForeColor = Color.Green : CheckBox115.ForeColor = Color.Green
            CheckBox121.ForeColor = Color.Green : CheckBox119.ForeColor = Color.Green : CheckBox118.ForeColor = Color.Green : CheckBox117.ForeColor = Color.Green
            CheckBox122.ForeColor = Color.Green : CheckBox120.ForeColor = Color.Green

            語轉扭_bt.BackColor = Color.White : 語轉扭_bt.ForeColor = Color.Black : 修改_bt.BackColor = Color.White : 修改_bt.ForeColor = Color.Green

            清單1_dgv.EnableHeadersVisualStyles = True : 清單1_dgv.BackgroundColor = Color.White : 清單1_dgv.ColumnHeadersDefaultCellStyle.ForeColor = Color.Black
            清單1_dgv.DefaultCellStyle.BackColor = Color.White : 清單1_dgv.DefaultCellStyle.ForeColor = Color.Black
        Else
            Me.BackColor = Color.Black : 業務權限_tp.BackColor = Color.Black : 採購權限_tp.BackColor = Color.Black
            技術權限_tp.BackColor = Color.Black : 倉儲權限_tp.BackColor = Color.Black : 財務權限_tp.BackColor = Color.Black
            人事權限_tp.BackColor = Color.Black : 資料庫權限_tp.BackColor = Color.Black
            '----------------黑-------------------------------------------
            小間距1_ch.ForeColor = Color.White : 中間距1_ch.ForeColor = Color.White : 大間距1_ch.ForeColor = Color.White
            CheckBox1.ForeColor = Color.White : CheckBox22.ForeColor = Color.White : CheckBox7.ForeColor = Color.White : CheckBox5.ForeColor = Color.White
            CheckBox9.ForeColor = Color.White : CheckBox8.ForeColor = Color.White : CheckBox6.ForeColor = Color.White
            '----------------紅-------------------------------------------
            CheckBox74.ForeColor = Color.LightPink : CheckBox75.ForeColor = Color.LightPink : CheckBox2.ForeColor = Color.LightPink : CheckBox45.ForeColor = Color.LightPink
            CheckBox84.ForeColor = Color.LightPink : CheckBox41.ForeColor = Color.LightPink : CheckBox87.ForeColor = Color.LightPink : CheckBox88.ForeColor = Color.LightPink
            CheckBox43.ForeColor = Color.LightPink : CheckBox10.ForeColor = Color.LightPink : CheckBox44.ForeColor = Color.LightPink : CheckBox4.ForeColor = Color.LightPink
            CheckBox3.ForeColor = Color.LightPink : CheckBox23.ForeColor = Color.LightPink : CheckBox24.ForeColor = Color.LightPink : CheckBox89.ForeColor = Color.LightPink
            CheckBox91.ForeColor = Color.LightPink : CheckBox92.ForeColor = Color.LightPink : CheckBox93.ForeColor = Color.LightPink : CheckBox94.ForeColor = Color.LightPink
            CheckBox95.ForeColor = Color.LightPink : CheckBox96.ForeColor = Color.LightPink : CheckBox97.ForeColor = Color.LightPink : CheckBox46.ForeColor = Color.LightPink
            CheckBox47.ForeColor = Color.LightPink : CheckBox48.ForeColor = Color.LightPink : CheckBox49.ForeColor = Color.LightPink : CheckBox50.ForeColor = Color.LightPink
            CheckBox25.ForeColor = Color.LightPink : CheckBox26.ForeColor = Color.LightPink : CheckBox27.ForeColor = Color.LightPink : CheckBox60.ForeColor = Color.LightPink
            CheckBox116.ForeColor = Color.LightPink : CheckBox107.ForeColor = Color.LightPink : CheckBox98.ForeColor = Color.LightPink : CheckBox101.ForeColor = Color.LightPink
            CheckBox103.ForeColor = Color.LightPink : CheckBox102.ForeColor = Color.LightPink : CheckBox33.ForeColor = Color.LightPink : CheckBox34.ForeColor = Color.LightPink
            CheckBox35.ForeColor = Color.LightPink : CheckBox90.ForeColor = Color.LightPink : CheckBox15.ForeColor = Color.LightPink : CheckBox16.ForeColor = Color.LightPink
            CheckBox17.ForeColor = Color.LightPink : CheckBox109.ForeColor = Color.LightPink : CheckBox108.ForeColor = Color.LightPink : CheckBox105.ForeColor = Color.LightPink
            CheckBox53.ForeColor = Color.LightPink : CheckBox104.ForeColor = Color.LightPink : CheckBox106.ForeColor = Color.LightPink : CheckBox110.ForeColor = Color.LightPink
            CheckBox54.ForeColor = Color.LightPink : CheckBox55.ForeColor = Color.LightPink
            '----------------藍-------------------------------------------
            CheckBox40.ForeColor = Color.LightBlue : CheckBox32.ForeColor = Color.LightBlue : CheckBox61.ForeColor = Color.LightBlue : CheckBox99.ForeColor = Color.LightBlue
            CheckBox62.ForeColor = Color.LightBlue : CheckBox114.ForeColor = Color.LightBlue : CheckBox52.ForeColor = Color.LightBlue : CheckBox51.ForeColor = Color.LightBlue
            CheckBox42.ForeColor = Color.LightBlue : CheckBox11.ForeColor = Color.LightBlue : CheckBox12.ForeColor = Color.LightBlue : CheckBox13.ForeColor = Color.LightBlue
            CheckBox14.ForeColor = Color.LightBlue : CheckBox100.ForeColor = Color.LightBlue : CheckBox69.ForeColor = Color.LightBlue : CheckBox70.ForeColor = Color.LightBlue
            CheckBox71.ForeColor = Color.LightBlue : CheckBox18.ForeColor = Color.LightBlue : CheckBox111.ForeColor = Color.LightBlue : CheckBox112.ForeColor = Color.LightBlue
            CheckBox113.ForeColor = Color.LightBlue : CheckBox19.ForeColor = Color.LightBlue : CheckBox21.ForeColor = Color.LightBlue : CheckBox76.ForeColor = Color.LightBlue
            CheckBox67.ForeColor = Color.LightBlue : CheckBox65.ForeColor = Color.LightBlue : CheckBox79.ForeColor = Color.LightBlue : CheckBox77.ForeColor = Color.LightBlue
            CheckBox68.ForeColor = Color.LightBlue : CheckBox66.ForeColor = Color.LightBlue : CheckBox64.ForeColor = Color.LightBlue : CheckBox78.ForeColor = Color.LightBlue
            CheckBox63.ForeColor = Color.LightBlue : CheckBox129.ForeColor = Color.LightBlue
            '----------------綠-------------------------------------------
            CheckBox123.ForeColor = Color.LightGreen : CheckBox124.ForeColor = Color.LightGreen : CheckBox125.ForeColor = Color.LightGreen : CheckBox126.ForeColor = Color.LightGreen
            CheckBox127.ForeColor = Color.LightGreen : CheckBox128.ForeColor = Color.LightGreen : CheckBox20.ForeColor = Color.LightGreen : CheckBox36.ForeColor = Color.LightGreen
            CheckBox73.ForeColor = Color.LightGreen : CheckBox37.ForeColor = Color.LightGreen : CheckBox38.ForeColor = Color.LightGreen : CheckBox39.ForeColor = Color.LightGreen
            CheckBox28.ForeColor = Color.LightGreen : CheckBox72.ForeColor = Color.LightGreen : CheckBox29.ForeColor = Color.LightGreen : CheckBox30.ForeColor = Color.LightGreen
            CheckBox31.ForeColor = Color.LightGreen : CheckBox82.ForeColor = Color.LightGreen : CheckBox83.ForeColor = Color.LightGreen : CheckBox81.ForeColor = Color.LightGreen
            CheckBox80.ForeColor = Color.LightGreen : CheckBox58.ForeColor = Color.LightGreen : CheckBox57.ForeColor = Color.LightGreen : CheckBox56.ForeColor = Color.LightGreen
            CheckBox59.ForeColor = Color.LightGreen : CheckBox85.ForeColor = Color.LightGreen : CheckBox86.ForeColor = Color.LightGreen : CheckBox115.ForeColor = Color.LightGreen
            CheckBox121.ForeColor = Color.LightGreen : CheckBox119.ForeColor = Color.LightGreen : CheckBox118.ForeColor = Color.LightGreen : CheckBox117.ForeColor = Color.LightGreen
            CheckBox122.ForeColor = Color.LightGreen : CheckBox120.ForeColor = Color.LightGreen

            語轉扭_bt.BackColor = Color.DimGray : 語轉扭_bt.ForeColor = Color.White : 修改_bt.BackColor = Color.DimGray : 修改_bt.ForeColor = Color.LightGreen

            清單1_dgv.EnableHeadersVisualStyles = False : 清單1_dgv.BackgroundColor = Color.DimGray : 清單1_dgv.ColumnHeadersDefaultCellStyle.ForeColor = Color.White
            清單1_dgv.ColumnHeadersDefaultCellStyle.BackColor = Color.Black
            清單1_dgv.DefaultCellStyle.BackColor = Color.Black : 清單1_dgv.DefaultCellStyle.ForeColor = Color.White
        End If
    End Sub
End Class