﻿Module SQL_生產管理系統
    '---------------------生產排程-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_生產排程明細表_讀取()
        ConnOpen()
        SQL1 = "SELECT      生產排程明細表.流水號, 生產排程明細表.流水號 AS 項次, 生產排程明細表.開工時間,生產排程明細表.廠區, 生產排程明細表.物料簡稱 AS 產品,  
                            生產排程明細表.日生產數量 AS 產量, 生產排程明細表.完工時間, 生產排程明細表.出庫時間, 生產排程明細表.入庫數量, 生產排程明細表.出庫數量, 
                            生產排程明細表.負責人, OW空白圖片.圖片 AS 完工, OW空白圖片.圖片 AS 刪除, 生產排程明細表.料號
                FROM         生產排程明細表 LEFT OUTER JOIN
                            OW空白圖片 ON 生產排程明細表.流水號 = OW空白圖片.選擇
                WHERE      (生產排程明細表.完工時間 = '') AND (生產排程明細表.狀態 = '投產')
                ORDER BY    生產排程明細表.開工時間 DESC, 生產排程明細表.廠區"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_生產排程暫存表_讀取()
        ConnOpen()
        SQL1 = "SELECT      生產排程暫存表.流水號, 生產排程暫存表.流水號 AS 項次, 生產排程暫存表.廠區, 生產排程暫存表.物料簡稱 AS 產品, 生產排程暫存表.產量, 
                            生產排程暫存表.負責人, OW空白圖片.圖片 AS 刪除, 生產排程暫存表.料號
                FROM        生產排程暫存表  LEFT OUTER JOIN
                            OW空白圖片 ON 生產排程暫存表.流水號 = OW空白圖片.選擇                   
                ORDER BY    生產排程暫存表.廠區, 生產排程暫存表.負責人"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_生產排程報廢表_讀取()
        ConnOpen()
        SQL1 = "SELECT      生產排程明細表.流水號, 生產排程明細表.流水號 AS 項次, 生產排程明細表.完工時間,生產排程明細表.廠區, 生產排程明細表.物料簡稱 AS 產品,  
                            生產排程明細表.出庫數量 AS 損壞量, 生產排程明細表.開工時間, 生產排程明細表.出庫時間, 生產排程明細表.入庫數量, OW空白圖片.圖片 AS 刪除, 
                            生產排程明細表.料號
                FROM         生產排程明細表 LEFT OUTER JOIN
                            OW空白圖片 ON 生產排程明細表.流水號 = OW空白圖片.選擇
                WHERE      (生產排程明細表.完工時間 <> '') AND (生產排程明細表.狀態 = '報廢')
                ORDER BY    生產排程明細表.開工時間 DESC, 生產排程明細表.廠區"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_排程物料單_物料規格讀取()
        ConnOpen()
        SQL1 = "Select  物料編碼庫.原則說明 As 品名, 物料資訊控制表.群組碼, 物料資訊控制表.料號原則, 物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定
                FROM    物料資訊控制表 INNER JOIN 物料編碼庫 ON 物料資訊控制表.群組碼 = 物料編碼庫.群組碼 AND 物料資訊控制表.料號原則 = 物料編碼庫.料號原則
                WHERE  (物料資訊控制表.料號原則 LIKE N'" & PA & "')"
        CmdSet_For_dr()
    End Sub

    Friend Sub SQL_新增排程明細表資料(流水號 As String, 廠區 As String, 料號 As String, 生產數 As String, 入庫數 As String, 待出庫數 As String, 出庫數 As String,
                                      開工時間 As String, 完工時間 As String, 待出庫時間 As String, 出庫時間 As String, 負責人 As String, 狀態 As String,
                                      物料簡稱 As String)
        ConnOpen()
        SQL1 = "INSERT INTO 生產排程明細表(流水號, 廠區, 料號, 日生產數量, 入庫數量, 待出庫數, 出庫數量, 開工時間, 完工時間, 待出庫時間, 出庫時間, 負責人, 狀態, 物料簡稱)
                VALUES (N'" & 流水號 & "', N'" & 廠區 & "', N'" & 料號 & "', N'" & 生產數 & "', N'" & 入庫數 & "', N'" & 待出庫數 & "', N'" & 出庫數 & "',
                        N'" & 開工時間 & "', N'" & 完工時間 & "', N'" & 待出庫時間 & "', N'" & 出庫時間 & "', N'" & 負責人 & "', N'" & 狀態 & "', N'" & 物料簡稱 & "')"
        CmdSet_For_dr()
    End Sub
    'Friend Sub SQL_新增排程報廢資料(開工時間 As String, 完工時間 As String, 出庫時間 As String)
    '    ConnOpen()

    '    SQL1 = "INSERT INTO 生產排程明細表(流水號, 廠區, 料號, 日生產數量, 入庫數量, 出庫數量, 開工時間, 完工時間, 出庫時間, 負責人, 狀態, 物料簡稱)
    '            VALUES (N'" & PA1 & "', N'" & 生產排程表.廠區_cb.Text & "', N'" & 生產排程表.料號_tb.Text & "', 
    '                   N'0', N'0', N'" & 生產排程表.報廢數量_tb.Text & "', N'" & 開工時間 & "',  N'" & 完工時間 & "',  N'" & 出庫時間 & "', 
    '                   N'" & 生產排程表.負責人_cb.Text & "', N'報廢', N'" & 生產排程表.產品簡稱_tb.Text & "')"
    '    CmdSet_For_dr()
    'End Sub
    Friend Sub SQL_匯入排程明細表資料(開工時間 As String, 完工時間 As String, 出庫時間 As String)
        ConnOpen()
        SQL1 = "INSERT INTO 生產排程明細表(流水號, 廠區, 料號, 日生產數量, 入庫數量, 出庫數量, 開工時間, 完工時間, 出庫時間, 負責人, 狀態, 物料簡稱)
                VALUES (N'" & PA1 & "', N'" & PA2 & "', N'" & PA3 & "', N'" & PA4 & "', N'0', N'0', 
                N'" & 開工時間 & "',  N'" & 完工時間 & "',  N'" & 出庫時間 & "', N'" & PA5 & "', N'投產', N'" & PA6 & "')"
        CmdSet_For_dr()
    End Sub
    'Friend Sub SQL_新增排程暫存表資料()
    '    ConnOpen()
    '    SQL1 = "INSERT INTO 生產排程暫存表(流水號, 廠區, 料號, 產量, 負責人, 物料簡稱)
    '            VALUES (N'" & PA1 & "', N'" & 生產排程表.廠區_cb.Text & "', N'" & 生產排程表.料號_tb.Text & "', 
    '                   N'" & 生產排程表.日生產數_tb.Text & "', N'" & 生產排程表.負責人_cb.Text & "', N'" & 生產排程表.產品簡稱_tb.Text & "')"
    '    CmdSet_For_dr()
    'End Sub
    Friend Sub SQL_查找排程最後一筆流水號()
        ConnOpen()
        SQL1 = "SELECT Top (1) 流水號  FROM  生產排程明細表  Order by 流水號 desc"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_查找暫存排程最後流水號()
        ConnOpen()
        SQL1 = "SELECT Top (1) 流水號  FROM  生產排程暫存表  Order by 流水號 desc"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_排程明細指定刪除(指定流水號 As String)
        ConnOpen()
        SQL1 = "DELETE FROM 生產排程明細表 WHERE (流水號 LIKE N'" & 指定流水號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_排程暫存指定刪除()
        ConnOpen()
        SQL1 = "DELETE FROM 生產排程暫存表 WHERE (流水號 LIKE N'" & PA & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_排程表完工項目資料_更新()
        ConnOpen()
        SQL1 = "UPDATE 生產排程明細表 SET 完工時間 = N'" & Strings.Format(Today(), "yyyy/MM/dd") & "' , 入庫數量 = N'" & PA2 & "' , 狀態 = N'完工'
                WHERE   (流水號 LIKE N'" & PA & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_修改排程明細表資料()
        ConnOpen()
        SQL1 = "UPDATE 生產排程明細表 SET 廠區 = N'" & PA2 & "', 料號 = N'" & PA3 & "', 日生產數量 = N'" & PA4 & "', 開工時間 = N'" & PA5 & "'
                WHERE  (流水號 LIKE N'" & PA & "')"
        CmdSet_For_dr()
    End Sub

    '---------------------生產庫存-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_生產庫存明細表_讀取()
        ConnOpen()
        SQL1 = "SELECT      物料簡稱 AS 項次, 物料簡稱 AS 產品, SUM(入庫數量) - SUM(出庫數量) AS 庫存, 料號
                FROM        生產排程明細表                
                GROUP BY    物料簡稱, 料號
                HAVING      SUM(入庫數量) - SUM(出庫數量) <> 0"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_搜尋庫存明細表_讀取(Search_word As String)
        ConnOpen()
        SQL1 = "SELECT      物料簡稱 AS 項次, 物料簡稱 AS 產品, SUM(入庫數量) - SUM(出庫數量) AS 庫存, 料號 
                FROM        生產排程明細表 
                WHERE       物料簡稱 LIKE N'%" & Search_word & "%'
                GROUP BY    物料簡稱, 料號
                HAVING      SUM(入庫數量) - SUM(出庫數量) <> 0"
        CmdSet_For_DGV()
    End Sub
    '---------------------生產日報-----------------------------------------------------------------------------------------------------------------
    'Friend Sub SQL_生產日報主表()
    '    ConnOpen()
    '    SQL1 = "SELECT    流水號, 日期, 加班情況, 臨時狀況, 備註, 總_簽名編碼, 總_核准日期, 副總_簽名編碼, 副_審核日期, 廠長_簽名編碼, 廠_確認日期
    '            FROM      生產日報控制表  ORDER BY  日期 DESC"
    '    CmdSet_For_DGV()
    'End Sub
    'Friend Sub SQL_新增日報表日期(add_date As String)
    '    ConnOpen()
    '    SQL1 = "INSERT INTO 生產日報控制表(流水號, 日期, 加班情況, 臨時狀況, 備註, 總_簽名編碼, 總_核准日期, 副總_簽名編碼, 副_審核日期, 廠長_簽名編碼, 
    '            廠_確認日期)
    '            VALUES      (N'" & PA1 & "', N'" & add_date & "', N'" & "" & "', N'" & "" & "', N'" & "" & "', N'" & "" & "', N'" & "" & "', 
    '                        N'" & "" & "', N'" & "" & "', N'" & "" & "', N'" & "" & "')"
    '    CmdSet_For_dr()
    'End Sub
    'Friend Sub SQL_查詢日報控制表日期(search_date As String)
    '    ConnOpen()
    '    SQL1 = "DECLARE     @指定日期 AS NVARCHAR(50)  
    '            SET         @指定日期 = '" & search_date & "'  
    '            SELECT      COUNT(*)
    '            FROM        生產日報控制表
    '            WHERE       CAST(日期 AS NVARCHAR(50)) = @指定日期"
    '    CmdSet_For_dr()
    'End Sub
    'Friend Sub SQL_查找日報最後一筆流水號()
    '    ConnOpen()
    '    SQL1 = "SELECT Top (1) 流水號  FROM  生產日報控制表  Order by 流水號 desc"
    '    CmdSet_For_dr()
    'End Sub
    'Friend Sub SQL_生產日報明細表_讀取()
    '    ConnOpen()
    '    SQL1 = "SELECT      流水號, 流水號 AS 項次, 廠區,  物料簡稱 AS 產品, 日生產數量 AS 產量, 負責人, 開工時間, 完工時間, 出庫時間, 入庫數量, 出庫數量, 
    '                        料號, 狀態
    '            FROM        生產排程明細表
    '            WHERE      (開工時間 = '" & PA & "') AND (廠區 = '" & PA1 & "') AND (((狀態 = '完工') OR (狀態 = '投產')))
    '            ORDER BY    物料簡稱, 負責人"
    '    CmdSet_For_DGV()
    'End Sub
    'Friend Sub SQL_修改日報控制表資料(search_date As String)
    '    ConnOpen()
    '    SQL1 = "UPDATE      生產日報控制表 SET 加班情況 = N'" & 生產日報表.加班情況_tb.Text & "', 臨時狀況 = N'" & 生產日報表.臨時狀況_tb.Text & "', 
    '                        備註 = N'" & 生產日報表.備註內容_tb.Text & "' 
    '            WHERE       (日期 LIKE N'" & search_date & "')"
    '    CmdSet_For_dr()
    'End Sub
    'Friend Sub SQL_修改生產日報控制表簽名0(審核主管 As String)
    '    Dim 審核日期 As String
    '    If 審核主管 = "總_簽名編碼" Then
    '        審核日期 = ", 總_核准日期"
    '    ElseIf 審核主管 = "副總_簽名編碼" Then
    '        審核日期 = ", 副_審核日期"
    '    ElseIf 審核主管 = "廠長_簽名編碼" Then
    '        審核日期 = ", 廠_確認日期"
    '    Else
    '        審核日期 = ""
    '    End If
    '    ConnOpen()
    '    SQL1 = "UPDATE 生產日報控制表 SET " & 審核主管 & " = N'" & 生產日報表.暫存簽名編碼_tb.Text & "'" & 審核日期 & " = N'" & Strings.Format(Today(), "yyyy/MM/dd") & "' WHERE 日期 LIKE N'" & PA & "'"
    '    CmdSet_For_dr()
    'End Sub
    'Friend Sub SQL_修改生產日報控制表簽名1()
    '    ConnOpen()
    '    SQL1 = "UPDATE 生產日報控制表 SET 總_簽名編碼 = N'" & 生產日報表.暫存簽名編碼_tb.Text & "', 總_核准日期 = N'" & Strings.Format(Today(), "yyyy/MM/dd") & "'
    '            WHERE   (日期 LIKE N'" & PA & "')"
    '    CmdSet_For_dr()
    'End Sub
    'Friend Sub SQL_修改生產日報控制表簽名2()
    '    ConnOpen()
    '    SQL1 = "UPDATE 生產日報控制表 SET 副總_簽名編碼 = N'" & 生產日報表.暫存簽名編碼_tb.Text & "', 副_審核日期 = N'" & Strings.Format(Today(), "yyyy/MM/dd") & "'
    '            WHERE   (日期 LIKE N'" & PA & "')"
    '    CmdSet_For_dr()
    'End Sub
    'Friend Sub SQL_修改生產日報控制表簽名3()
    '    ConnOpen()
    '    SQL1 = "UPDATE 生產日報控制表 SET 廠長_簽名編碼 = N'" & 生產日報表.暫存簽名編碼_tb.Text & "', 廠_確認日期 = N'" & Strings.Format(Today(), "yyyy/MM/dd") & "'
    '            WHERE   (日期 LIKE N'" & PA & "')"
    '    CmdSet_For_dr()
    'End Sub
    '---------------------生產月報-----------------------------------------------------------------------------------------------------------------

    Friend Sub SQL_讀取月份良品生產量(startDate As DateTime, 月份數 As Integer)
        ConnOpen()
        SQL1 = "SELECT 物料簡稱 AS 產品名稱, 完工時間, (SUM(入庫數量) - SUM(出庫數量)) AS 日總產量
                FROM 生產排程明細表 
                WHERE 完工時間 BETWEEN N'" & startDate.ToString("yyyy/MM/dd") & "' AND N'" & startDate.AddMonths(月份數).AddDays(-1).ToString("yyyy/MM/dd") & "'
                GROUP BY 物料簡稱, 完工時間
                ORDER BY 完工時間, 物料簡稱"
        CmdSet_For_dr()
    End Sub
    '---------------------出貨排程-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_出貨排程明細表_讀取()
        ConnOpen()
        SQL1 = "SELECT      生產排程明細表.流水號, 生產排程明細表.流水號 AS 項次, 生產排程明細表.待出庫時間 AS 預出貨時間, 
                            生產排程明細表.物料簡稱 AS 產品, 生產排程明細表.待出庫數 AS 預出貨數量, 生產排程明細表.出貨時間, 
                            生產排程明細表.出貨數量, OW空白圖片.圖片 AS 出貨, OW空白圖片.圖片 AS 刪除, 生產排程明細表.料號, 生產排程明細表.出庫數量                           
                FROM        生產排程明細表 LEFT OUTER JOIN
                            OW空白圖片 ON 生產排程明細表.流水號 = OW空白圖片.選擇
                WHERE      (生產排程明細表.出貨時間 IS NULL OR 生產排程明細表.出貨時間 = '') AND (生產排程明細表.狀態 = '準備出庫')
                ORDER BY    生產排程明細表.出庫時間 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_新增出庫排程明細表資料(流水號 As String, 物料料號 As String, 出庫數量 As String, 出庫時間 As String, 待出庫數 As String, 待出庫時間 As String,
                                          負責人 As String, 狀態 As String, 物料簡稱 As String)
        ConnOpen()
        SQL1 = "INSERT INTO 生產排程明細表(流水號, 料號, 出庫數量, 出庫時間, 待出庫數, 待出庫時間, 負責人, 狀態, 物料簡稱, 廠區, 日生產數量, 入庫數量, 開工時間, 完工時間)
                VALUES (N'" & 流水號 & "', N'" & 物料料號 & "', N'" & 出庫數量 & "', N'" & 出庫時間 & "', N'" & 待出庫數 & "', N'" & 待出庫時間 & "',
                        N'" & 負責人 & "', N'" & 狀態 & "', N'" & 物料簡稱 & "', N'', N'0', N'0', N'', N'')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_查詢物料組合件(Material_num As String)
        ConnOpen()
        SQL1 = "SELECT      A6 
                FROM        物料規格表 
                WHERE       料號 LIKE N'" & Material_num & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_出貨庫存有無料明細表_讀取(Material_num As String)
        ConnOpen()
        SQL1 = "SELECT      SUM(入庫數量) - SUM(出庫數量) AS 庫存
                FROM        生產排程明細表
                WHERE       料號 LIKE N'" & Material_num & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_查詢物料組合件2(Material_num As String)
        ConnOpen()
        SQL1 = "SELECT      流水號, 物料料號 
                FROM        物料組合控制表 
                WHERE       (物料料號 LIKE N'" & Material_num & "') AND (啟用 = 'True')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_出貨BOM表子料件_讀取(BOM編號 As String)
        ConnOpen()
        SQL1 = "SELECT      子料號, 子料數量, 子料簡稱 
                FROM        物料組合明細表 
                WHERE       (BOM編號 LIKE N'" & BOM編號 & "')"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_查詢刪除物料是否正確(流水號 As String)
        ConnOpen()
        SQL1 = "SELECT      料號
                FROM        生產排程明細表 
                WHERE       流水號 LIKE N'" & 流水號 & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_出貨修改排程明細表資料()
        ConnOpen()
        SQL1 = "UPDATE 生產排程明細表 SET 料號 = N'" & PA2 & "', 出庫數量 = N'" & PA3 & "', 出庫時間 = N'" & PA4 & "', 物料簡稱 = N'" & PA5 & "'
                WHERE  (流水號 LIKE N'" & PA & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_出貨排程表項目資料_更新()
        ConnOpen()
        SQL1 = "UPDATE 生產排程明細表 SET 廠區 = N'' , 日生產數量 = N'0', 入庫數量 = N'0', 待出庫數 = N'" & PA2 & "', 出庫數量 = N'" & PA2 & "', 
                                          出庫時間 = N'" & Strings.Format(Today(), "yyyy/MM/dd") & "' , 出貨時間 = N'" & Strings.Format(Today(), "yyyy/MM/dd") & "' , 
                                          出貨數量 = N'" & PA2 & "' , 狀態 = N'完成出庫'
                WHERE   (流水號 LIKE N'" & PA & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_查詢出貨控制表日期(search_date As String)
        ConnOpen()
        SQL1 = "DECLARE     @指定日期 AS NVARCHAR(50)  
                SET         @指定日期 = '" & search_date & "'  
                SELECT      COUNT(*)
                FROM        出貨日報控制表
                WHERE       CAST(出貨日期 AS NVARCHAR(50)) = @指定日期"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_查找出貨日報最後流水號()
        ConnOpen()
        SQL1 = "SELECT Top (1) 流水號  FROM  出貨日報控制表  Order by 流水號 desc"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_新增出貨日報表日期(add_date As String)
        ConnOpen()
        SQL1 = "INSERT INTO 出貨日報控制表(流水號, 出貨日期)
                VALUES      (N'" & PA1 & "', N'" & add_date & "')"
        CmdSet_For_dr()
    End Sub
    '---------------------出貨日報-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_出貨日報主表()
        ConnOpen()
        SQL1 = "SELECT    流水號, 出貨日期
                FROM      出貨日報控制表  ORDER BY  出貨日期 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_出貨歷史明細表_讀取()
        ConnOpen()
        SQL1 = "SELECT  出貨時間 AS 項次, 出貨時間, 物料簡稱 AS 產品, 出貨數量, 料號
                FROM    生產排程明細表
                WHERE   (出貨時間 LIKE N'" & PA & "') AND (狀態 = '完成出庫')"
        CmdSet_For_DGV()
    End Sub
End Module
