﻿
Imports System.Runtime.Remoting.Contexts
Imports System.Web.UI.WebControls
Imports System.Windows.Forms.VisualStyles.VisualStyleElement

Public Class 物料資料庫
    Dim 修改狀態 As String
    Private Sub Set_物料明細表單()
        Dim ds1 As New DataSet : 物料明細_DGV.DataSource = Nothing : ds1.Clear()
        SetDGV樣式值(物料明細_DGV)
        SQL_物料明細表_讀取()
        da.Fill(ds1) : 物料明細_DGV.DataSource = ds1.Tables(0) : conn.Close()
        物料明細_DGV.Columns(5).Visible = False
        物料明細_DGV.Columns(0).FillWeight = 25 : 物料明細_DGV.Columns(1).FillWeight = 50
        物料明細_DGV.Columns(2).FillWeight = 100 : 物料明細_DGV.Columns(3).FillWeight = 40
        物料明細_DGV.Columns(4).FillWeight = 25 : 物料明細_DGV.Columns(6).FillWeight = 50

        For i As Integer = 0 To 物料明細_DGV.Rows.Count - 1
            物料明細_DGV.Rows(i).Cells("項次").Value = i + 1
        Next
    End Sub
    Public Sub Set_搜尋庫存清單()
        ' 執行 Set_物料組合件明細表() 即會更新一次點名清單
        Dim ds1 As New DataSet : 物料明細_DGV.DataSource = Nothing : ds1.Clear()
        SetDGV樣式值(物料明細_DGV)

        Dim Search_select As String = String.Empty
        If Search_名稱_cb.Checked Then : Search_select = "名稱"
        ElseIf Search_料號_cb.Checked Then : Search_select = "物料料號"
        ElseIf Search_種類_cb.Checked Then : Search_select = "種類"
        End If
        SQL_搜尋物料明細表_讀取(txtKeyword_tb.Text, Search_select)
        da.Fill(ds1) : 物料明細_DGV.DataSource = ds1.Tables(0) : conn.Close()
        物料明細_DGV.Columns(5).Visible = False
        物料明細_DGV.Columns(0).FillWeight = 25 : 物料明細_DGV.Columns(1).FillWeight = 50
        物料明細_DGV.Columns(2).FillWeight = 100 : 物料明細_DGV.Columns(3).FillWeight = 40
        物料明細_DGV.Columns(4).FillWeight = 25 : 物料明細_DGV.Columns(6).FillWeight = 50

        For i As Integer = 0 To 物料明細_DGV.Rows.Count - 1
            物料明細_DGV.Rows(i).Cells("項次").Value = i + 1
        Next
    End Sub
    ' ↓↓---------------------- Set DataGridView 樣式相關功能 ----------------------↓↓
    Private Sub SetDGV樣式值(dgv As DataGridView)
        ' Set DataGridView 樣式值
        dgv.DataSource = Nothing
        dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        dgv.ColumnHeadersHeight = 25
        dgv.AllowUserToAddRows = False
        dgv.RowTemplate.Height = Get_DGV_Row_Height()
    End Sub
    Private Function Get_DGV_Row_Height() As Integer
        ' 用來決定DGV的每一Row高度，在於哪一個間距 CheckBox被按下
        If 小間距_ch.Checked = True And 中間距_ch.Checked = False And 大間距_ch.Checked = False Then : Return 25
        ElseIf 小間距_ch.Checked = False And 中間距_ch.Checked = True And 大間距_ch.Checked = False Then : Return 45
        ElseIf 小間距_ch.Checked = False And 中間距_ch.Checked = False And 大間距_ch.Checked = True Then : Return 65
        End If
        Return 25 ' Default value
    End Function

    Private Sub InitializeForm()
        ' 表單畫面初始化
        Me.WindowState = 0 : Me.AutoScroll = True
        MyMod.清單字體大小調整()
        物料明細_DGV.RowsDefaultCellStyle.Font = New System.Drawing.Font("微軟正黑體", 12)
        物料明細_DGV.EditMode = DataGridViewEditMode.EditOnEnter

        修改狀態 = "" : 儲存_bt.Enabled = False : 種類_cb.Enabled = False : 單位_cb.Enabled = False
        物料料號_tb.ReadOnly = True : 物料料號_tb.BackColor = SystemColors.Window
        物料名稱_tb.ReadOnly = True : 物料名稱_tb.BackColor = SystemColors.Window
        備註_tb.ReadOnly = True : 備註_tb.BackColor = SystemColors.Window
        隱藏_pl1.SendToBack()


        ' 為每個項目添加事件處理程序
        AddHandler txtKeyword_tb.KeyDown, AddressOf txtKeyword_tb_KeyDown
        AddHandler ContextMenuStrip1.Items(0).Click, AddressOf 重新整理_ctsm_Click
        ' 將 ContextMenuStrip 與 TextBox 關聯
        物料明細_DGV.ContextMenuStrip = ContextMenuStrip1
    End Sub
    Private Sub 物料資料庫_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        InitializeForm()
    End Sub
    Private Sub 物料資料庫_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        首次開啟 = False : Set_物料明細表單()
    End Sub
    Private Sub 物料資料庫_Closing(sender As Object, e As EventArgs) Handles MyBase.Closing
        ' 如果主表單未新增，而子表單已新增
    End Sub
    Private Sub 物料資料庫_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        'MyMod.虛擬桌面開啟()
    End Sub

    Private Sub 間距_ch_CheckedChanged(sender As Object, e As EventArgs) Handles 小間距_ch.Click, 大間距_ch.Click, 中間距_ch.Click
        ' ↓↓---------------------- DataGridView 間距設定相關功能 ----------------------↓↓
        Dim 小間距 As Boolean = (sender Is 小間距_ch) : Dim 中間距 As Boolean = (sender Is 中間距_ch) : Dim 大間距 As Boolean = (sender Is 大間距_ch)
        小間距_ch.Checked = 小間距 : 中間距_ch.Checked = 中間距 : 大間距_ch.Checked = 大間距
        If 小間距 Then
            MyMod.間距設定存檔_1()
        ElseIf 中間距 Then
            MyMod.間距設定存檔_2()
        ElseIf 大間距 Then
            MyMod.間距設定存檔_3()
        End If
        Set_物料明細表單()
    End Sub  ' ↑↑---------------------- DataGridView 間距設定相關功能 ----------------------↑↑
    Private Sub txtKeyword_tb_KeyDown(sender As Object, e As KeyEventArgs)
        If e.KeyCode = Keys.Enter Then
            ' 在此處插入當Enter鍵被按下時您想執行的代碼
            Set_搜尋庫存清單()
            '查詢DGV中的關鍵字(物料明細_DGV, txtKeyword_tb)

            ' 如果您不希望在按下Enter鍵時換行或進行其他默認操作，可以添加以下代碼：
            e.Handled = True
            e.SuppressKeyPress = True
        End If
    End Sub
    Private Sub 關鍵字_bt_Click(sender As Object, e As EventArgs) Handles 關鍵字_bt.Click
        Set_搜尋庫存清單()
        '查詢DGV中的關鍵字(物料明細_DGV, txtKeyword_tb)
    End Sub
    Private Sub CheckBox_CheckedChanged(sender As Object, e As EventArgs) Handles Search_名稱_cb.CheckedChanged, Search_料號_cb.CheckedChanged, Search_種類_cb.CheckedChanged

        Dim 選中Ch_Box As Windows.Forms.CheckBox = DirectCast(sender, Windows.Forms.CheckBox)

        If 選中Ch_Box.Checked Then
            Dim 其餘Ch_Box As New List(Of Windows.Forms.CheckBox) From {
                Search_名稱_cb, Search_料號_cb, Search_種類_cb
            }

            For Each 其餘中的任一Ch_Box In 其餘Ch_Box
                If 其餘中的任一Ch_Box IsNot 選中Ch_Box Then
                    其餘中的任一Ch_Box.Checked = False
                End If
            Next
        End If
    End Sub
    Private Sub 物料明細_DGV_CellClick(ByVal sender As System.Object, ByVal e As DataGridViewCellEventArgs) Handles 物料明細_DGV.CellClick
        If e.RowIndex = -1 Then : Else
            If 修改狀態 <> "新增" And 修改狀態 <> "修改" Then
                物料料號_tb.Text = 物料明細_DGV.Rows(e.RowIndex).Cells("料號").Value.ToString
                物料名稱_tb.Text = 物料明細_DGV.Rows(e.RowIndex).Cells("名稱").Value.ToString
                種類_cb.Text = 物料明細_DGV.Rows(e.RowIndex).Cells("種類").Value.ToString
                單位_cb.Text = 物料明細_DGV.Rows(e.RowIndex).Cells("單位").Value.ToString
                備註_tb.Text = 物料明細_DGV.Rows(e.RowIndex).Cells("備註").Value.ToString
            Else
                MGB("新 增 或 修 改 資 料 時 無 法 點 選 其 他 物 料 !", 1)
            End If
        End If
    End Sub

    Private Sub 小間距_ch_MouseEnter(sender As Object, e As EventArgs) Handles 小間距_ch.MouseEnter
        ToolTip1.SetToolTip(Me.小間距_ch, "物料明細表格間距小")
    End Sub
    Private Sub 中間距_ch_MouseEnter(sender As Object, e As EventArgs) Handles 中間距_ch.MouseEnter
        ToolTip1.SetToolTip(Me.中間距_ch, "物料明細表格間距中")
    End Sub
    Private Sub 大間距_ch_MouseEnter(sender As Object, e As EventArgs) Handles 大間距_ch.MouseEnter
        ToolTip1.SetToolTip(Me.大間距_ch, "物料明細表格間距大")
    End Sub
    Private Sub 物料新增_tb_MouseEnter(sender As Object, e As EventArgs) Handles 物料新增_tb.MouseEnter
        ToolTip1.SetToolTip(Me.物料新增_tb, "新增物料資料")
    End Sub
    Private Sub 修改_bt_MouseEnter(sender As Object, e As EventArgs) Handles 修改_bt.MouseEnter
        ToolTip1.SetToolTip(Me.修改_bt, "修改物料資料")
    End Sub
    Private Sub 物料刪除_tb_MouseEnter(sender As Object, e As EventArgs) Handles 物料刪除_tb.MouseEnter
        ToolTip1.SetToolTip(Me.物料刪除_tb, "刪除物料資料")
    End Sub
    Private Sub 儲存_bt_MouseEnter(sender As Object, e As EventArgs) Handles 儲存_bt.MouseEnter
        ToolTip1.SetToolTip(Me.儲存_bt, "儲存新增或修改物料資料")
    End Sub

    Private Function 產生新流水號(流水號標頭 As String, 查詢表單名稱 As String, SQL欄位名稱 As String)
        Dim 新流水號 As String
        SQL_查找表單最後流水號_共用(查詢表單名稱, SQL欄位名稱)
        If dr.Read() Then : 新流水號 = dr(SQL欄位名稱).ToString() : Else : 新流水號 = 流水號標頭 & "00000000" : End If : conn.Close()
        Dim NUM1 As Integer = Integer.Parse(新流水號.Substring(2)) + 1
        新流水號 = 流水號標頭 & NUM1.ToString().PadLeft(8, "0"c)
        Return 新流水號
    End Function
    Private Sub 物料新增_tb_Click(sender As Object, e As EventArgs) Handles 物料新增_tb.Click
        修改狀態 = "新增"
        修改_bt.Enabled = False : 物料刪除_tb.Enabled = False : 儲存_bt.Enabled = True
        物料名稱_tb.ReadOnly = False : 種類_cb.Enabled = True : 單位_cb.Enabled = True : 備註_tb.ReadOnly = False
        物料料號_tb.Text = "" : 物料名稱_tb.Text = "" : 種類_cb.Text = "" : 單位_cb.Text = "" : 備註_tb.Text = ""


        ' 新增途徑: 先查出 最後一筆流水號 方可自動產生流水號 
        物料料號_tb.Text = 產生新流水號("MT", "物料規格表", "物料料號")
    End Sub

    Private Sub 修改_bt_Click(sender As Object, e As EventArgs) Handles 修改_bt.Click
        MGB("確 定 要 修 改 資 料 嗎?", 2) ' 確認修改操作
        If 訊息回應 <> "YES" Then Return

        If String.IsNullOrEmpty(物料料號_tb.Text) Then ' 提早退出，以減少嵌套
            MGB("請 點 選 擇 物 料 表 資 料 !", 1)
            Exit Sub
        End If

        修改狀態 = "修改"
        物料新增_tb.Enabled = False : 修改_bt.Enabled = False : 儲存_bt.Enabled = True : 物料刪除_tb.Enabled = False
        物料名稱_tb.ReadOnly = False : 種類_cb.Enabled = True : 單位_cb.Enabled = True : 備註_tb.ReadOnly = False
    End Sub

    Private Sub 儲存_bt_Click(sender As Object, e As EventArgs) Handles 儲存_bt.Click
        MGB("確 定 要 儲 存 資 料 嗎?", 2) ' 確認儲存操作
        If 訊息回應 <> "YES" Then Return

        If 修改狀態 = "新增" Then
            'SQL_物料明細表_名稱查詢_讀取(物料名稱_tb.Text)
            'If dr.Read Then
            '    MGB("已 有 此 物 料 名 稱，無 法 添 加 !", 1)
            '    Exit Sub
            'End If
            SQL_物料明細表_新增(物料料號_tb.Text, 物料名稱_tb.Text, 種類_cb.Text, 單位_cb.Text, 備註_tb.Text)
        ElseIf 修改狀態 = "修改" Then
            SQL_物料明細表_更新(物料料號_tb.Text, 物料名稱_tb.Text, 種類_cb.Text, 單位_cb.Text, 備註_tb.Text)
        End If
        Set_物料明細表單() : conn.Close()

        修改狀態 = ""
        物料新增_tb.Enabled = True : 修改_bt.Enabled = True : 儲存_bt.Enabled = False : 物料刪除_tb.Enabled = True
        物料名稱_tb.ReadOnly = True : 種類_cb.Enabled = False : 單位_cb.Enabled = False : 備註_tb.ReadOnly = True

    End Sub

    Private Sub 物料刪除_tb_Click(sender As Object, e As EventArgs) Handles 物料刪除_tb.Click
        If String.IsNullOrEmpty(物料料號_tb.Text) Then ' 提早退出，以減少嵌套
            MGB("請 點 選 擇 物 料 表 資 料 !", 1)
            Exit Sub
        End If

        MGB("確 定 要 刪 除 資 料 嗎?", 2) ' 確認刪除操作
        If 訊息回應 <> "YES" Then Exit Sub

        SQL_物料明細表_刪除(物料料號_tb.Text)
        Set_物料明細表單() : conn.Close()
        物料料號_tb.Text = "" : 物料名稱_tb.Text = "" : 種類_cb.Text = "" : 單位_cb.Text = "" : 備註_tb.Text = ""

        MGB("資 料 刪 除 完 成 !", 1)
    End Sub

    Private Sub 重新整理_ctsm_Click(sender As Object, e As EventArgs) Handles 重新整理_ctsm.Click
        Set_物料明細表單()
    End Sub
End Class