﻿Module SQL_技術管理系統

    Friend Sub SQL_下拉清單_讀取(Text As String)
        ConnOpen()
        SQL1 = "SELECT DISTINCT " & Text & "
                FROM            配方控制表"
        CmdSet_For_DGV()
    End Sub

    Friend Sub SQL_配方控制表_讀取(油脂種類 As String)
        ConnOpen()
        SQL1 = "SELECT     配方編號 AS 項次, 配方編號, 產品名稱, 油脂種類, 季節, 出貨類型, 制定日期, 生產噸數, 認證標章,
                        CASE
                            WHEN 代工 = 1 THEN '是'
                            ELSE '否'
                        END AS 代工, 
                           備註, 製表簽名編碼, 核對簽名編碼, 核准簽名編碼, 發行章編碼, 舊編號, 物料料號, 版本, 停用
                FROM      配方控制表
                WHERE     油脂種類 LIKE N'%" & 油脂種類 & "%'
                ORDER BY  配方編號, 季節 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_搜尋配方控制表_讀取(Search_word As String)
        ConnOpen()
        SQL1 = "SELECT     配方編號 AS 項次, 配方編號, 產品名稱, 油脂種類, 季節, 出貨類型, 制定日期, 生產噸數, 認證標章,
                        CASE
                            WHEN 代工 = 1 THEN '是'
                            ELSE '否'
                        END AS 代工, 
                           備註, 製表簽名編碼, 核對簽名編碼, 核准簽名編碼, 發行章編碼, 舊編號, 物料料號, 版本, 停用
                FROM      配方控制表
                WHERE     (產品名稱 LIKE N'%" & Search_word & "%') OR (油脂種類 LIKE N'%" & Search_word & "%') OR (季節 LIKE N'%" & Search_word & "%') OR 
                          (認證標章 LIKE N'%" & Search_word & "%') 
                ORDER BY  配方編號, 季節 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方控制表_產品名稱查詢_讀取(產品名稱 As String, 油脂種類 As String, 季節 As String, 出貨類型 As String, 版本 As String)
        ConnOpen()
        SQL1 = "SELECT    產品名稱
                FROM      配方控制表
                WHERE     (產品名稱 LIKE N'" & 產品名稱 & "') AND (油脂種類 LIKE N'" & 油脂種類 & "') AND (季節 LIKE N'" & 季節 & "') 
                AND (出貨類型 LIKE N'" & 出貨類型 & "') AND (版本 LIKE N'" & 版本 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方控制表_新增(配方編號 As String, 產品名稱 As String, 油脂種類 As String, 季節 As String, 出貨類型 As String, 制定日期 As String,
                                生產噸數 As String, 認證標章 As String, 代工 As Boolean, 備註 As String, 製表簽名編碼 As String, 核對簽名編碼 As String, 核准簽名編碼 As String,
                                 發行章編碼 As String, 舊編號 As String, 物料料號 As String, 版本 As String, 停用 As Boolean)
        ConnOpen()
        SQL1 = "INSERT INTO     配方控制表 (配方編號, 產品名稱, 油脂種類, 季節, 出貨類型, 制定日期, 生產噸數, 認證標章, 代工, 備註, 製表簽名編碼, 核對簽名編碼, 
                                            核准簽名編碼, 發行章編碼, 舊編號, 物料料號, 版本, 停用) 
                VALUES          (N'" & 配方編號 & "', N'" & 產品名稱 & "', N'" & 油脂種類 & "', N'" & 季節 & "', N'" & 出貨類型 & "', N'" & 制定日期 & "',
                                N'" & 生產噸數 & "', N'" & 認證標章 & "', N'" & 代工 & "', N'" & 備註 & "', N'" & 製表簽名編碼 & "', N'" & 核對簽名編碼 & "', 
                                N'" & 核准簽名編碼 & "', N'" & 發行章編碼 & "', N'" & 舊編號 & "', N'" & 物料料號 & "', N'" & 版本 & "', N'" & 停用 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方控制表_更新(配方編號 As String, 產品名稱 As String, 油脂種類 As String, 季節 As String, 出貨類型 As String, 生產噸數 As String,
                            認證標章 As String, 代工 As Boolean, 備註 As String, 製表簽名編碼 As String, 核對簽名編碼 As String, 核准簽名編碼 As String,
                                 發行章編碼 As String, 舊編號 As String, 物料料號 As String, 版本 As String, 停用 As Boolean)
        ConnOpen()
        SQL1 = "UPDATE  配方控制表 SET 產品名稱 = N'" & 產品名稱 & "', 油脂種類 = N'" & 油脂種類 & "', 季節 = N'" & 季節 & "', 出貨類型 = N'" & 出貨類型 & "'
                        , 生產噸數 = N'" & 生產噸數 & "', 認證標章 = N'" & 認證標章 & "', 代工 = N'" & 代工 & "', 備註 = N'" & 備註 & "', 製表簽名編碼 = N'" & 製表簽名編碼 & "'
                        , 核對簽名編碼 = N'" & 核對簽名編碼 & "', 核准簽名編碼 = N'" & 核准簽名編碼 & "', 發行章編碼 = N'" & 發行章編碼 & "', 舊編號 = N'" & 舊編號 & "'
                        , 物料料號 = N'" & 物料料號 & "', 版本 = N'" & 版本 & "', 停用 = N'" & 停用 & "'
                WHERE   (配方編號 LIKE N'" & 配方編號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方控制表_依配方編號_刪除(配方編號 As String)
        ConnOpen()
        SQL1 = "DELETE FROM 配方控制表 
                WHERE (配方編號 LIKE N'" & 配方編號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方明細表_關閉時查詢_讀取(配方編號 As String)
        ConnOpen()
        SQL1 = "SELECT      配方編號
                FROM        配方明細表
                WHERE       配方編號 LIKE N'" & 配方編號 & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方明細表原料油_讀取(配方編號 As String)
        ConnOpen()
        SQL1 = "SELECT      配方明細表.明細流水號 AS 項次, 配方明細表.明細流水號, 配方明細表.原料名稱, 配方明細表.油脂百分比 AS [油脂%], 配方明細表.產品百分比 AS [產品%], 
                            配方明細表.重量, 配方明細表.物料料號, OW空白圖片.圖片 AS 刪除
                FROM        配方明細表 LEFT OUTER JOIN
                            OW空白圖片 ON 配方明細表.明細流水號 = OW空白圖片.選擇
                WHERE       (配方明細表.配方編號 LIKE N'" & 配方編號 & "') AND (配方明細表.原料種類 LIKE '原料油')
                ORDER BY    配方明細表.明細流水號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方明細表乳化劑_讀取(配方編號 As String)
        ConnOpen()
        SQL1 = "SELECT      配方明細表.明細流水號 AS 項次, 配方明細表.明細流水號, 配方明細表.原料名稱, 配方明細表.過敏源資訊 AS 過敏源, 配方明細表.產品百分比 AS [產品%], 
                            配方明細表.重量, 配方明細表.物料料號, OW空白圖片.圖片 AS 刪除
                FROM        配方明細表 LEFT OUTER JOIN
                            OW空白圖片 ON 配方明細表.明細流水號 = OW空白圖片.選擇
                WHERE       (配方明細表.配方編號 LIKE N'" & 配方編號 & "') AND (配方明細表.原料種類 LIKE '乳化劑')
                ORDER BY    配方明細表.明細流水號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方明細表香料_讀取(配方編號 As String)
        ConnOpen()
        SQL1 = "SELECT      配方明細表.明細流水號 AS 項次, 配方明細表.明細流水號, 配方明細表.原料名稱, 配方明細表.過敏源資訊 AS 過敏源, 配方明細表.產品百分比 AS [產品%], 
                            配方明細表.重量, 配方明細表.物料料號, OW空白圖片.圖片 AS 刪除
                FROM        配方明細表 LEFT OUTER JOIN
                            OW空白圖片 ON 配方明細表.明細流水號 = OW空白圖片.選擇
                WHERE       (配方明細表.配方編號 LIKE N'" & 配方編號 & "') AND (配方明細表.原料種類 LIKE '香料')
                ORDER BY    配方明細表.明細流水號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方明細表其他_讀取(配方編號 As String)
        ConnOpen()
        SQL1 = "SELECT      配方明細表.明細流水號 AS 項次, 配方明細表.明細流水號, 配方明細表.原料名稱, 配方明細表.過敏源資訊 AS 過敏源, 配方明細表.產品百分比 AS [產品%], 
                            配方明細表.重量, 配方明細表.物料料號, OW空白圖片.圖片 AS 刪除
                FROM        配方明細表 LEFT OUTER JOIN
                            OW空白圖片 ON 配方明細表.明細流水號 = OW空白圖片.選擇
                WHERE       (配方明細表.配方編號 LIKE N'" & 配方編號 & "') AND (配方明細表.原料種類 LIKE '其他')
                ORDER BY    配方明細表.明細流水號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方明細表著色劑_讀取(配方編號 As String)
        ConnOpen()
        SQL1 = "SELECT      配方明細表.明細流水號 AS 項次, 配方明細表.明細流水號, 配方明細表.原料名稱, 配方明細表.過敏源資訊 AS 過敏源, 配方明細表.產品百分比 AS [產品%], 
                            配方明細表.重量, 配方明細表.物料料號, OW空白圖片.圖片 AS 刪除
                FROM        配方明細表 LEFT OUTER JOIN
                            OW空白圖片 ON 配方明細表.明細流水號 = OW空白圖片.選擇
                WHERE       (配方明細表.配方編號 LIKE N'" & 配方編號 & "') AND (配方明細表.原料種類 LIKE '著色劑')
                ORDER BY    配方明細表.明細流水號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方明細表_原料查詢_讀取(配方編號 As String, 物料料號 As String)
        ConnOpen()
        SQL1 = "SELECT    物料料號                        
                FROM      配方明細表
                WHERE     (物料料號 LIKE N'" & 物料料號 & "') AND (配方編號 LIKE N'" & 配方編號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方明細表_原料_新增(明細流水號 As String, 配方編號 As String, 原料種類 As String, 原料名稱 As String, 油脂百分比 As String, 產品百分比 As String,
                                重量 As String, 過敏源資訊 As String, 物料料號 As String)
        ConnOpen()
        SQL1 = "INSERT INTO     配方明細表 (明細流水號, 配方編號, 原料種類, 原料名稱, 油脂百分比, 產品百分比, 重量, 過敏源資訊, 物料料號) 
                VALUES          (N'" & 明細流水號 & "', N'" & 配方編號 & "', N'" & 原料種類 & "', N'" & 原料名稱 & "', N'" & 油脂百分比 & "', N'" & 產品百分比 & "',
                                N'" & 重量 & "', N'" & 過敏源資訊 & "', N'" & 物料料號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方明細表_更新(明細流水號 As String, 配方編號 As String, 原料種類 As String, 原料名稱 As String, 油脂百分比 As String, 產品百分比 As String,
                                重量 As String, 過敏源資訊 As String, 物料料號 As String)
        ConnOpen()
        SQL1 = "UPDATE  配方明細表 SET 原料種類 = N'" & 原料種類 & "', 原料名稱 = N'" & 原料名稱 & "', 油脂百分比 = N'" & 油脂百分比 & "', 產品百分比 = N'" & 產品百分比 & "'
                        , 重量 = N'" & 重量 & "', 過敏源資訊 = N'" & 過敏源資訊 & "', 物料料號 = N'" & 物料料號 & "'
                WHERE   (明細流水號 LIKE N'" & 明細流水號 & "') AND (配方編號 LIKE N'" & 配方編號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方明細表_依配方編號_刪除(配方編號 As String)
        ConnOpen()
        SQL1 = "DELETE FROM 配方明細表 
                WHERE (配方編號 LIKE N'" & 配方編號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方明細表_依明細流水號_刪除(明細流水號 As String)
        ConnOpen()
        SQL1 = "DELETE FROM 配方明細表 
                WHERE (明細流水號 LIKE N'" & 明細流水號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_選項類型_讀取()
        ConnOpen()
        SQL1 = "SELECT DISTINCT 選項類型
                FROM            配方選項表"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方規格表油脂_讀取(配方編號 As String)
        ConnOpen()
        SQL1 = "SELECT      配方規格表.規格流水號 AS 項次, 配方規格表.規格流水號, 配方規格表.項目, 配方規格表.標準, OW空白圖片.圖片 AS 刪除
                FROM        配方規格表 LEFT OUTER JOIN
                            OW空白圖片 ON 配方規格表.規格流水號 = OW空白圖片.選擇
                WHERE       ( 配方規格表.配方編號 LIKE N'" & 配方編號 & "') AND ( 配方規格表.規格類型 LIKE '油脂規格')
                ORDER BY    規格流水號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方規格表產品_讀取(配方編號 As String)
        ConnOpen()
        SQL1 = "SELECT      配方規格表.規格流水號 AS 項次, 配方規格表.規格流水號, 配方規格表.項目, 配方規格表.標準, OW空白圖片.圖片 AS 刪除
                FROM        配方規格表 LEFT OUTER JOIN
                            OW空白圖片 ON 配方規格表.規格流水號 = OW空白圖片.選擇
                WHERE       ( 配方規格表.配方編號 LIKE N'" & 配方編號 & "') AND ( 配方規格表.規格類型 LIKE '產品規格')
                ORDER BY    規格流水號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方規格表_規格查詢_讀取(配方編號 As String, 規格類型 As String, 項目 As String)
        ConnOpen()
        SQL1 = "SELECT    項目                        
                FROM      配方規格表
                WHERE     (規格類型 LIKE N'" & 規格類型 & "') AND (配方編號 LIKE N'" & 配方編號 & "') AND (項目 LIKE N'" & 項目 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方規格表_新增(規格流水號 As String, 配方編號 As String, 規格類型 As String, 項目 As String, 標準 As String)
        ConnOpen()
        SQL1 = "INSERT INTO     配方規格表 (規格流水號, 配方編號, 規格類型, 項目, 標準) 
                VALUES          (N'" & 規格流水號 & "', N'" & 配方編號 & "', N'" & 規格類型 & "', N'" & 項目 & "', N'" & 標準 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方規格表_更新(規格流水號 As String, 配方編號 As String, 規格類型 As String, 項目 As String, 標準 As String)
        ConnOpen()
        SQL1 = "UPDATE  配方規格表 SET 規格類型 = N'" & 規格類型 & "', 項目 = N'" & 項目 & "', 標準 = N'" & 標準 & "'
                WHERE   (規格流水號 LIKE N'" & 規格流水號 & "') AND (配方編號 LIKE N'" & 配方編號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方規格表_依規格流水號_刪除(規格流水號 As String)
        ConnOpen()
        SQL1 = "DELETE FROM 配方規格表 
                WHERE (規格流水號 LIKE N'" & 規格流水號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方規格表_依配方編號_刪除(配方編號 As String)
        ConnOpen()
        SQL1 = "DELETE FROM 配方規格表 
                WHERE (配方編號 LIKE N'" & 配方編號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方原料選項_讀取(種類 As String)
        ConnOpen()
        SQL1 = "SELECT      物料規格表.物料料號 AS 項次, 物料規格表.物料料號, 物料規格表.名稱, OW空白圖片.圖片 AS 加入
                FROM        物料規格表 LEFT OUTER JOIN
                            OW空白圖片 ON 物料規格表.物料料號 = OW空白圖片.選擇
                WHERE       物料規格表.種類 LIKE N'" & 種類 & "'
                ORDER BY    物料規格表.名稱 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方規格選項_讀取(規格類型 As String)
        ConnOpen()
        SQL1 = "SELECT      配方選項表.流水號 AS 項次, 配方選項表.流水號, 配方選項表.選項內容, OW空白圖片.圖片 AS 加入
                FROM        配方選項表 LEFT OUTER JOIN
                            OW空白圖片 ON 配方選項表.流水號 = OW空白圖片.選擇
                WHERE       配方選項表.選項類型 LIKE N'" & 規格類型 & "'
                ORDER BY    配方選項表.選項內容 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_配方規格選項_內容_讀取(規格類型 As String, 選項內容 As String)
        ConnOpen()
        SQL1 = "SELECT      流水號
                FROM        配方選項表 
                WHERE       (選項類型 LIKE N'" & 規格類型 & "') AND (選項內容 LIKE N'" & 選項內容 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_配方規格選項_新增(流水號 As String, 選項類型 As String, 選項內容 As String)
        ConnOpen()
        SQL1 = "INSERT INTO     配方選項表 (流水號, 選項類型, 選項內容) 
                VALUES          (N'" & 流水號 & "', N'" & 選項類型 & "', N'" & 選項內容 & "')"
        CmdSet_For_dr()
    End Sub
End Module
