﻿Option Explicit On
Imports System.IO
Imports System.Text
Public Class OW_ERP_SYS
    ReadOnly 對話框(30), 已選捷徑(100) As String
    Dim sysnud As String
    Dim 系統關閉, 捷徑關閉, 無設定 As Boolean
    Dim NSD As Integer = 0
    Dim RI As Integer = -1
    Dim SK As String = "要查找的 KEY"
    Dim Str As String = Application.StartupPath
    Private m_ChildFormNumber As Integer
    Private Sub ShowNewForm(ByVal sender As Object, ByVal e As EventArgs) Handles 開新視窗_tsm.Click
        ' 建立子表單的新執行個體。
        ' 將它變成這個 MDI 表單的子表單，然後才顯示。
        Dim ChildForm As New Form With {
            .MdiParent = Me
        }
        m_ChildFormNumber += 1
        ChildForm.Text = "視窗 " & m_ChildFormNumber
        ChildForm.Show()
    End Sub
    Private Sub ExitToolsStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles 結束_tsm.Click
        Me.Close()
    End Sub
    Private Sub CascadeToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles 重疊顯示_tsm.Click
        Me.LayoutMdi(MdiLayout.Cascade)
    End Sub
    Private Sub TileVerticalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles 垂直並排_tsm.Click
        Me.LayoutMdi(MdiLayout.TileVertical)
    End Sub
    Private Sub TileHorizontalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles 水平並排_tsm.Click
        Me.LayoutMdi(MdiLayout.TileHorizontal)
    End Sub
    Private Sub ArrangeIconsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles 排列圖示_tsm.Click
        Me.LayoutMdi(MdiLayout.ArrangeIcons)
    End Sub
    Private Sub CloseAllToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles 全部關閉_tsm.Click
        ' 關閉父表單的所有子表單。
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next : MyMod.虛擬桌面開啟()
    End Sub
    Private Sub 初始化系統語言()
        If File.Exists(Application.StartupPath + "\LANGUAGE_FILE.csv") Then
            Dim filereader = My.Computer.FileSystem.OpenTextFileReader(Application.StartupPath + "\LANGUAGE_FILE.csv", System.Text.Encoding.Default)
            Dim line As String = filereader.ReadLine()
            While Not (line Is Nothing)
                line = filereader.ReadLine()
                If line <> Nothing Then
                    line = line.Replace("""", "") : Dim separator As String = "-" : Dim result() As String = line.Split(separator)
                    If result.Count > 4 Then
                        Dim key As String = result(0).ToString() & "-" & result(1).ToString() & "-" & result(2).ToString()
                        Dim value As String = result(3).ToString()
                        For i As Integer = 4 To result.Count - 1 : value += "-" & result(i) : Next
                        If value.EndsWith(",") Then : value = value.Substring(0, value.Length - 1) : End If : 系統語言字典.Add(key, value)
                    Else
                        Dim key As String = result(0).ToString() & "-" & result(1).ToString() & "-" & result(2).ToString()
                        Dim value As String = result(3).ToString()
                        If value.EndsWith(",") Then : value = value.Substring(0, value.Length - 1) : End If : 系統語言字典.Add(key, value)
                    End If
                End If
            End While
        End If
    End Sub
    Private Sub OW_ERP_SYS_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        初始化系統語言() : Me.Size = New Point(1360, 745) : MyMod.清單字體大小調整()
        MyBrowser.SendToBack() : MyBrowser.Visible = False
        Dim screenBounds As Rectangle = Screen.PrimaryScreen.Bounds
        If screenBounds.Width < Me.Width Or screenBounds.Height < Me.Height Then
            Me.WindowState = 2
        Else
            Me.Left = (screenBounds.Width - Me.Width) / 2
            Me.Top = (screenBounds.Height - Me.Height) / 2
        End If
        '------------------------優化UI-------------------------------------------------------------------------------------------------------------------------------------------------
        Me.DoubleBuffered = True
        '------------------------系統登入時宣告-------------------------------------------------------------------------------------------------------------------------------------------------
        介面 = "H001" : 系統關閉 = False : 捷徑數量 = 0
        Dim SS1, SS2 As Integer : SS1 = 527 : SS2 = 325 : 幣別 = " (RP)" : Dim NB1 As Integer = 0
        '------------------------工程管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        製程配方表_tsm.Visible = CC(8) : 製程配方表_p.Visible = CC(8)
        If CC(8) = True Then : 捷徑名稱(捷徑數量) = "CC01" : 顯示名稱(捷徑數量) = 製程配方表_tsm.Text : 捷徑類別(捷徑數量) = "工程" : 捷徑數量 += 1 : End If
        技術系統管理_tsm.Visible = CC(8)
        '------------------------倉儲管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        倉儲控制表_tsm.Visible = CC(46) : 倉儲控制表_p.Visible = CC(46)
        If CC(46) = True Then : 捷徑名稱(捷徑數量) = "DC01" : 顯示名稱(捷徑數量) = 倉儲控制表_tsm.Text : 捷徑類別(捷徑數量) = "倉儲" : 捷徑數量 += 1 : End If
        物料資料庫_tsm.Visible = CC(70) : 物料資料庫_p.Visible = CC(70)
        If CC(70) = True Then : 捷徑名稱(捷徑數量) = "DC09" : 顯示名稱(捷徑數量) = 物料資料庫_tsm.Text : 捷徑類別(捷徑數量) = "倉儲" : 捷徑數量 += 1 : End If
        倉儲系統管理_tsm.Visible = CC(9)

        '------------------------人事管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        人員基本資料_tsm.Visible = CC(17) : 人員基本資料_p.Visible = CC(17)
        If CC(17) = True Then : 捷徑名稱(捷徑數量) = "FC04" : 顯示名稱(捷徑數量) = 人員基本資料_tsm.Text : 捷徑類別(捷徑數量) = "人事" : 捷徑數量 += 1 : End If
        人員ID卡系統配置設定_tsm.Visible = CC(23) : 人員ID卡系統配置設定_p.Visible = CC(23)
        If CC(23) = True Then : 捷徑名稱(捷徑數量) = "FC05" : 顯示名稱(捷徑數量) = 人員ID卡系統配置設定_tsm.Text : 捷徑類別(捷徑數量) = "人事" : 捷徑數量 += 1 : End If
        人事系統管理_tsm.Visible = CC(22)
        '------------------------資料庫管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        系統使用者管理_tsm.Visible = CC(2) : 系統權限預設表_tsm.Visible = CC(84) : 系統組織架構設定_tsm.Visible = CC(41) : 部門權限設定_tsm.Visible = CC(87)
        系統通用變數管理_tsm.Visible = CC(43) : 系統編碼規則_tsm.Visible = CC(10) : 系統對應電腦註冊_tsm.Visible = CC(44) : 系統執行檔版本管理_tsm.Visible = CC(4)
        FTP資料夾管理_tsm.Visible = CC(3) : 簽名檔管理_tsm.Visible = CC(21) : 資料庫系統管理_tsm.Visible = CC(1) : 系統開發用共享文件_tsm.Visible = CC(19)
        If 登入人級別 = "00" Then : 開發模板庫_tsm.Visible = True : Else : 開發模板庫_tsm.Visible = False : End If

        '------------------------ToolStripSeparator隱藏
        '------------------------資料庫管理系統-------------------------------------------------------------------------------------------------------------------------------------------------
        If CC(2) = False And CC(84) = False Then : ToolStripSeparator19.Visible = False : End If
        If CC(43) = False And CC(10) = False And CC(44) = False Then : ToolStripSeparator20.Visible = False : End If
        If CC(4) = False And CC(3) = False Then : ToolStripSeparator5.Visible = False : End If
        If CC(41) = False And CC(87) = False Then : ToolStripSeparator7.Visible = False : End If
        If 登入人級別 = "00" Then : ToolStripSeparator27.Visible = True : Else : ToolStripSeparator27.Visible = False : End If
    End Sub
    Private Sub 捷徑設定()
        For I As Integer = 0 To NSD : If PA20 = 已選捷徑(I) Then : 捷徑關閉 = False : Exit For : End If : Next
    End Sub
    Private Sub HXGPSERPSYS_Siz()
        NSD = 0 : Dim Str As String = Application.StartupPath : For i As Integer = 0 To 100 : 已選捷徑(i) = "" : Next
        If File.Exists(Str + "\" & gUserName & ".txt") Then
            Dim filereader = My.Computer.FileSystem.OpenTextFileReader(Str + "\" & gUserName & ".txt", System.Text.Encoding.Default) : Dim line As String = filereader.ReadLine()
            While Not (line Is Nothing) : line = filereader.ReadLine() : 已選捷徑(NSD) = line : NSD += 1 : End While : filereader.Close() : 無設定 = False
        Else : 無設定 = True : End If

        Dim 位置X As Integer : Dim 位置Y As Integer = 82 : Dim 位置Y1 As Integer = 83 : Dim Y可放 As Integer : If 系統語言 = "繁體中文" Then : 位置X = 125 : Else : 位置X = 125 : End If
        Dim 視窗X As Integer = 虛擬桌_pl.Size.Width : Dim 視窗Y As Integer = 虛擬桌_pl.Size.Height
        Dim X可放 As Integer = 視窗X / 位置X : If 系統語言 = "繁體中文" Then : Y可放 = 視窗Y / 位置Y : Else : Y可放 = 視窗Y / 位置Y + 0 : End If
        Dim 總共可放 As Integer = X可放 * Y可放
        Dim X已放, Y已放, 已經放置 As Integer : Dim 段落1, 段落4 As Boolean
        '---------製程---------------------------------------------------------------------------------------------------------------
        If 無設定 = True Then : 製程配方表_p.Visible = False
        Else : PA20 = "CC01" : 捷徑關閉 = True : 捷徑設定()
            If 捷徑關閉 = True Then : 製程配方表_p.Visible = False : Else : 製程配方表_p.Visible = True : End If : End If
        If 製程配方表_p.Visible = True Then : 段落4 = True : 製程配方表_p.Size = New Point(位置X, 位置Y1)
            If 已經放置 = 0 Then : 製程配方表_p.Location = New Point(0, 0) : X已放 = 0 : Y已放 = 1 : 已經放置 += 1
            Else : 製程配方表_p.Location = New Point(X已放 * 位置X, Y已放 * 位置Y) : Y已放 += 1 : 已經放置 += 1 : If Y已放 >= Y可放 Then : X已放 += 1 : Y已放 = 0 : End If : End If
        End If

        '---------倉儲---------------------------------------------------------------------------------------------------------------
        If 無設定 = True Then : 倉儲控制表_p.Visible = False
        Else : PA20 = "DC01" : 捷徑關閉 = True : 捷徑設定()
            If 捷徑關閉 = True Then : 倉儲控制表_p.Visible = False : Else : 倉儲控制表_p.Visible = True : End If : End If
        If 倉儲控制表_p.Visible = True Then : 段落1 = True : 倉儲控制表_p.Size = New Point(位置X, 位置Y1)
            If 已經放置 = 0 Then : 倉儲控制表_p.Location = New Point(0, 0) : X已放 = 0 : Y已放 = 1 : 已經放置 += 1
            Else : 倉儲控制表_p.Location = New Point(X已放 * 位置X, Y已放 * 位置Y) : Y已放 += 1 : 已經放置 += 1 : If Y已放 >= Y可放 Then : X已放 += 1 : Y已放 = 0 : End If : End If
        End If

        If 無設定 = True Then : 物料資料庫_p.Visible = False
        Else : PA20 = "DC09" : 捷徑關閉 = True : 捷徑設定()
            If 捷徑關閉 = True Then : 物料資料庫_p.Visible = False : Else : 物料資料庫_p.Visible = True : End If : End If
        If 物料資料庫_p.Visible = True Then : 段落1 = True : 物料資料庫_p.Size = New Point(位置X, 位置Y1)
            If 已經放置 = 0 Then : 物料資料庫_p.Location = New Point(0, 0) : X已放 = 0 : Y已放 = 1 : 已經放置 += 1
            Else : 物料資料庫_p.Location = New Point(X已放 * 位置X, Y已放 * 位置Y) : Y已放 += 1 : 已經放置 += 1 : If Y已放 >= Y可放 Then : X已放 += 1 : Y已放 = 0 : End If : End If
        End If

        '---------人事---------------------------------------------------------------------------------------------------------------
        If 無設定 = True Then : 人員基本資料_p.Visible = False
        Else : PA20 = "FC04" : 捷徑關閉 = True : 捷徑設定()
            If 捷徑關閉 = True Then : 人員基本資料_p.Visible = False : Else : 人員基本資料_p.Visible = True : End If : End If
        If 人員基本資料_p.Visible = True Then : 人員基本資料_p.Size = New Point(位置X, 位置Y1)
            If 已經放置 = 0 Then : 人員基本資料_p.Location = New Point(0, 0) : X已放 = 0 : Y已放 = 1 : 已經放置 += 1
            Else : 人員基本資料_p.Location = New Point(X已放 * 位置X, Y已放 * 位置Y) : Y已放 += 1 : 已經放置 += 1 : If Y已放 >= Y可放 Then : X已放 += 1 : Y已放 = 0 : End If : End If
        End If

        If 無設定 = True Then : 人員ID卡系統配置設定_p.Visible = False
        Else : PA20 = "FC05" : 捷徑關閉 = True : 捷徑設定()
            If 捷徑關閉 = True Then : 人員ID卡系統配置設定_p.Visible = False : Else : 人員ID卡系統配置設定_p.Visible = True : End If : End If
        If 人員ID卡系統配置設定_p.Visible = True Then : 人員ID卡系統配置設定_p.Size = New Point(位置X, 位置Y1)
            If 已經放置 = 0 Then : 人員ID卡系統配置設定_p.Location = New Point(0, 0) : X已放 = 0 : Y已放 = 1 : 已經放置 += 1
            Else : 人員ID卡系統配置設定_p.Location = New Point(X已放 * 位置X, Y已放 * 位置Y) : Y已放 += 1 : 已經放置 += 1 : If Y已放 >= Y可放 Then : X已放 += 1 : Y已放 = 0 : End If : End If
        End If
        延遲1.Enabled = True
    End Sub
    Private Sub OW_ERP_SYS_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        If 登入人級別 = "00" Then : Me.Text = Me.Text & "  --  " & g_conn_type & "  --  " & gUserName & "  --  系統版本  :" & 版本 & " -- Server IP : " & 登入人IP
        Else : Me.Text = Me.Text & "  --  " & g_conn_type & "  --  " & gUserName & "  --  系統版本  :" & 版本 : End If

        系統語言1_cb.Text = 系統語言
        '-----------------------帳號下拉清單------------------------------------------------------------------------------------------------------------
        SQL_帳號讀取()
        使用者1_cb.Items.Clear() : While (dr.Read()) : 使用者1_cb.Items.Add(dr("姓名")) : End While : conn.Close()
        使用者1_cb.Text = gUserName
        If 登入人級別 = "00" Then : 使用者1_cb.Visible = True : Else : 使用者1_cb.Visible = False : End If

        '-----------------------捷徑設定詢問------------------------------------------------------------------------------------------------------------
        If 無設定 = True Then
            MGB(對話框(24), 1)
            If 訊息回應 = "YES" Then : 桌面捷徑設定.ShowDialog() : End If
        End If
        '-----------------------測試伺服器登入通知------------------------------------------------------------------------------------------------------------
        If 登入人IP = "106.1.48.106,4567" Then
            MGB(對話框(25), 1)
        End If
        '-----------------------更新系統公告------------------------------------------------------------------------------------------------------------
        If 不用WEB = False Then
            If File.Exists(Str + "\OPUPDATE.txt") Then
                介面 = "H001" : File.Delete(Str & "\OPUPDATE.txt")                'WEB說明頁面.Show()
            Else : End If
        End If

        HXGPSERPSYS_Siz()
    End Sub
    Private Sub OW_ERP_SYS_SizeChanged(sender As Object, e As EventArgs) Handles MyBase.SizeChanged
        HXGPSERPSYS_Siz()
    End Sub
    Private Sub OW_ERP_SYS_Unload(sender As Object, e As EventArgs) Handles MyBase.Closing
        系統關閉 = True : If 判斷重登 = True Then : 判斷重登 = False : Else : 判斷重登 = False : LoginForm1.Close() : End If
    End Sub
    Private Sub 重置()
        首次開啟 = True : 不變形 = True : 工人 = False
        BL = False : BL1 = False : BL2 = False : BL3 = False : BL4 = False : BL5 = False : BL6 = False : BL7 = False : BL8 = False
        NU1 = 0 : NU2 = 0 : NU3 = 0 : NU4 = 0 : NU5 = 0
        BBL1 = "" : BBL2 = "" : BBL3 = "" : BBL4 = "" : BBL5 = "" : BBL6 = "" : PA = "" : PA1 = "" : PA2 = "" : PA3 = "" : PA4 = "" : PA5 = "" : PA6 = "" : PA7 = "" : PA8 = "" : PA9 = ""
        PA10 = "" : PA11 = "" : PA12 = "" : PA13 = "" : PA14 = "" : PA15 = "" : PA16 = "" : PA17 = "" : PA18 = "" : PA19 = "" : PA20 = "" : PA21 = "" : PA22 = "" : PA23 = "" : PA24 = ""
        PA25 = "" : PA26 = "" : PA27 = "" : PA28 = "" : PA29 = "" : PA30 = "" : PA31 = "" : PA32 = "" : PA33 = "" : PA34 = "" : PA35 = "" : PA36 = "" : PA37 = "" : PA38 = "" : PA39 = ""
        PA40 = "" : PA41 = "" : PA42 = "" : PA43 = "" : PA44 = "" : PA45 = "" : PA46 = "" : PA47 = "" : 列印用SQL = "" : 列印用SQL2 = "" : PPAA = "" : DTP = "" : DTP1 = "" : DTP2 = ""
        DTP3 = ""
        For i As Integer = 0 To 999 : H(i) = False : Next
    End Sub
    Private Sub 虛擬桌面隱藏()
        虛擬桌_pl.Visible = False
    End Sub
    '------------------------檔案-------------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 個人帳號管理_tsm_Click(sender As Object, e As EventArgs) Handles 個人帳號管理_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : 個人帳號管理.ShowDialog() : 個人帳號管理.BringToFront()
    End Sub
    Private Sub 桌面捷徑設定_tsm_Click(sender As Object, e As EventArgs) Handles 桌面捷徑設定_tsm.Click
        桌面捷徑設定.ShowDialog() : HXGPSERPSYS_Siz()
    End Sub
    '------------------------倉儲系統管理-------------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 物料資料庫_tsm_Click(sender As Object, e As EventArgs) Handles 物料資料庫_tsm.Click
        物料資料庫.Show() : 物料資料庫.BringToFront()
    End Sub
    Private Sub 物料資料庫_pb_Click(sender As Object, e As EventArgs) Handles 物料資料庫_pb.Click
        物料資料庫_tsm.PerformClick()
    End Sub
    Private Sub 物料資料庫_lb_Click(sender As Object, e As EventArgs) Handles 物料資料庫_lb.Click
        物料資料庫_tsm.PerformClick()
    End Sub
    '------------------------人事系統管理-------------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 人員基本資料_tsm_Click(sender As Object, e As EventArgs) Handles 人員基本資料_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : If 登入人級別 = "00" Then : BL = False : Else : BL = True : End If
        人員基本資料.Show() : 人員基本資料.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 人員基本資料_pb_Click(sender As Object, e As EventArgs) Handles 人員基本資料_pb.Click
        人員基本資料_tsm.PerformClick()
    End Sub
    Private Sub 人員基本資料_lb_Click(sender As Object, e As EventArgs) Handles 人員基本資料_lb.Click
        人員基本資料_tsm.PerformClick()
    End Sub
    Private Sub 人員ID卡系統配置設定_tsm_Click(sender As Object, e As EventArgs) Handles 人員ID卡系統配置設定_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : 人員ID卡系統配置設定.Show() : 人員ID卡系統配置設定.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 人員ID卡系統配置設定_pb_Click(sender As Object, e As EventArgs) Handles 人員ID卡系統配置設定_pb.Click
        人員ID卡系統配置設定_tsm.PerformClick()
    End Sub
    Private Sub 人員ID卡系統配置設定_lb_Click(sender As Object, e As EventArgs) Handles 人員ID卡系統配置設定_lb.Click
        人員ID卡系統配置設定_tsm.PerformClick()
    End Sub
    '------------------------技術系統管理-------------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 製程配方表_tsm_Click(sender As Object, e As EventArgs) Handles 製程配方表_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : 製程配方表.Show() : 製程配方表.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 製程配方表_pb_Click(sender As Object, e As EventArgs) Handles 製程配方表_pb.Click
        製程配方表_tsm.PerformClick()
    End Sub
    Private Sub 製程配方表_lb_Click(sender As Object, e As EventArgs) Handles 製程配方表_lb.Click
        製程配方表_tsm.PerformClick()
    End Sub
    '------------------------資料庫系統管理-------------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub FTP資料夾管理_tsm_Click(sender As Object, e As EventArgs) Handles FTP資料夾管理_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : FTP資料夾管理.Show() : FTP資料夾管理.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 系統執行檔版本管理_tsm_Click(sender As Object, e As EventArgs) Handles 系統執行檔版本管理_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : 系統執行檔版本管理.Show() : 系統執行檔版本管理.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 系統使用者管理_tsm_Click(sender As Object, e As EventArgs) Handles 系統使用者管理_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : BL = False : 系統使用者管理.Show() : 系統使用者管理.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 系統權限預設表_tsm_Click(sender As Object, e As EventArgs) Handles 系統權限預設表_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : 系統權限預設表.Show() : 系統權限預設表.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 簽名檔管理_tsm_Click(sender As Object, e As EventArgs) Handles 簽名檔管理_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : 簽名檔管理.Show() : 簽名檔管理.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 系統通用變數管理_tsm_Click(sender As Object, e As EventArgs) Handles 系統通用變數管理_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : 系統通用變數管理.Show() : 系統通用變數管理.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 系統編碼規則_tsm_Click(sender As Object, e As EventArgs) Handles 系統編碼規則_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : 系統編碼規則.Show() : 系統編碼規則.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 系統組織架構設定_tsm_Click(sender As Object, e As EventArgs) Handles 系統組織架構設定_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : 系統組織架構設定.Show() : 系統組織架構設定.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub 部門權限設定_tsm_Click(sender As Object, e As EventArgs) Handles 部門權限設定_tsm.Click
        For Each ChildForm As Form In Me.MdiChildren : ChildForm.Close() : Next
        重置() : 部門權限設定.Show() : 部門權限設定.BringToFront() : 虛擬桌面隱藏()
    End Sub
    Private Sub Calculator_bt_Click(sender As Object, e As EventArgs) Handles Calculator_bt.Click
        Shell("calc")     'PA = "" : 計算機.Show() : 計算機.BringToFront()
    End Sub
    Private Sub 網頁介面ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 網頁介面ToolStripMenuItem.Click
        If 不用WEB = False Then
            INB("請輸入要測試的網址，如果沒有請輸入 [1] ") : PA50 = 訊息回應 : 介面 = "H001"
            'WEB說明頁面.Show()
        Else : MsgBox("No Open Web") : End If
    End Sub
End Class